<?php

/* $Id: function.inc.php 2455 2008-12-01 17:10:08Z denis $ */

function nc_captcha_generate_hash() {

   $captcha_hash = md5(uniqid(rand(), true));
   return $captcha_hash;

}


function nc_captcha_generate_code($captcha_hash) {

   global $db;
   global $MODULE_VARS;

   //     

   $alphabet   = ( $MODULE_VARS['captcha']['ALPHABET'] ? $MODULE_VARS['captcha']['ALPHABET'] : 'ABCDEFGHKLMNOPRSTUVWXYZ');
   $num_chars  = ( $MODULE_VARS['captcha']['NUMBER_OF_CHARS'] ? $MODULE_VARS['captcha']['NUMBER_OF_CHARS'] : 5);

   if (strpos($num_chars, ".."))
   {
      $num_chars = preg_split("|\.+|", $num_chars);
      $num_chars = rand($num_chars[0], $num_chars[1]);
   }

   //    
   $alphabet_size = strlen($alphabet);
   $captcha_code = '';
   for ($i = 0; $i < $num_chars; $i++) {
      $captcha_code .= $alphabet[rand(0, $alphabet_size - 1)];
   }

   //   
   $db->query("REPLACE INTO Captchas (Captcha_Hash, Captcha_Code) VALUES ('$captcha_hash', '$captcha_code')");

   return $captcha_code;
}


function nc_captcha_verify_code($user_code, $user_hash = '') {

   global $db;
   global $MODULE_VARS;

   if (!$user_code) {
      return false;
   }

   $hidden_field_name = ( $MODULE_VARS['captcha']['HIDDEN_FIELD_NAME'] ? $MODULE_VARS['captcha']['HIDDEN_FIELD_NAME'] : 'nc_captcha_hash' );

   //    ,     GET  POST 
   if (!$user_hash) {
      if (!empty($_GET[$hidden_field_name])) {
         $user_hash = $_GET[$hidden_field_name];
      }
      if (!empty($_POST[$hidden_field_name])) {
         $user_hash = $_POST[$hidden_field_name];
      }
   }

   $captcha_duration = ( $MODULE_VARS['captcha']['DURATION'] ? $MODULE_VARS['captcha']['DURATION'] : 5 * 60 );

   $captchas_count = (int) $db->get_var("SELECT COUNT(*) FROM Captchas WHERE UPPER(Captcha_Code) = UPPER('$user_code') AND Captcha_Hash = '".$user_hash."' AND NOW() - Captcha_Created <= ".$captcha_duration);

   if ($captchas_count == 1) {
      $captcha_valid =  true;
   }
   else {
      $captcha_valid = false;
   }

   $db->query("DELETE FROM Captchas WHERE Captcha_Hash = '$user_hash' OR NOW() - Captcha_Created >= ".$captcha_duration);

   return $captcha_valid;
}




function nc_captcha_formfield($attributes = '') {

   global $MODULE_VARS, $SUB_FOLDER, $HTTP_ROOT_PATH;

   $hidden_field_name = ( $MODULE_VARS['captcha']['HIDDEN_FIELD_NAME'] ? $MODULE_VARS['captcha']['HIDDEN_FIELD_NAME'] : 'nc_captcha_hash');

   $captcha_hash = nc_captcha_generate_hash();

   return "<input type='hidden' name='".$hidden_field_name."' value='".$captcha_hash."'><img src='".$SUB_FOLDER.$HTTP_ROOT_PATH."modules/captcha/img.php?code=".$captcha_hash."'".($attributes ? " ".$attributes : "").">";
}



function nc_captcha_image($captcha_hash) {

  global $MODULE_VARS, $MODULE_FOLDER;

  $captcha_code = nc_captcha_generate_code($captcha_hash);

  //        ,
  //   
  include_once($MODULE_FOLDER."captcha/user_functions.inc.php");
  if (function_exists('nc_captcha_user_image')) { return nc_captcha_user_image($captcha_code); }

  // "" 
  //       GD   GIF
  if (!function_exists("imagegif")) {
    return false;
  }

  $num_chars = strlen($captcha_code);

  //     

  $img_width  = ( $MODULE_VARS['captcha']['IMAGE_WIDTH'] ? $MODULE_VARS['captcha']['IMAGE_WIDTH'] : 150 );
  $img_height = ( $MODULE_VARS['captcha']['IMAGE_HEIGHT'] ? $MODULE_VARS['captcha']['IMAGE_HEIGHT'] : 30 );
  $num_lines  = ( isset($MODULE_VARS['captcha']['NUMBER_OF_LINES']) ? $MODULE_VARS['captcha']['NUMBER_OF_LINES'] : 30 );

  $letter_width = (int) ($img_width / $num_chars);
  $captcha_image = imagecreate($img_width, $img_height);

  //  
  imagecolorallocate($captcha_image, 255, 255, 255);

  $background_color = imagecolorallocate($captcha_image, 255, 255, 255);
  $grey_color = rand(165, 225);
  $noise_color = imagecolorallocate($captcha_image, $grey_color, $grey_color, $grey_color);

  for( $i=0; $i<$num_lines; $i++ ) {
    imageline($captcha_image, mt_rand(0,$img_width), mt_rand(0,$img_height), mt_rand(0,$img_width), mt_rand(0,$img_height), $noise_color);
  }
  
  for ($i = 0; $i < $num_chars; $i++) {
    $font_size = $img_height * round(rand(50, 75)/100, 2);
    $text_color = imagecolorallocate($captcha_image, rand(0, 128), rand(0, 128), rand(0, 128));
    if ( function_exists("imagettftext") ) {
      $rand_x = rand(0, $letter_width - $font_size);
      $rand_y = $img_height - round( ($img_height - $font_size)/2 );
      imagettftext($captcha_image, $font_size, rand(-30,30), $i * $letter_width + $rand_x, $rand_y, $text_color, $MODULE_FOLDER."captcha/font.ttf" , $captcha_code[$i]);
    }
    else {
      $rand_font = rand(2, 5);
      $rand_x = rand(0, $letter_width - imagefontwidth($rand_font));
      $rand_y = rand(0, $img_height - imagefontheight($rand_font));
      imagestring($captcha_image, $rand_font, $i * $letter_width + $rand_x, $rand_y, $captcha_code[$i], $text_color);
    }
  }
  
  if ( preg_match("/^(\d)/is", phpversion(), $matches) && function_exists("imagettftext") && function_exists("imagefilter") ) {
    if ($matches[1]==5) imagefilter($captcha_image, IMG_FILTER_GAUSSIAN_BLUR);
  }
  
  return imagegif($captcha_image);
}


?>