<?php
/*
 * FCKeditor - The text editor for Internet - http://www.fckeditor.net
 * Copyright (C) 2003-2008 Frederico Caldeira Knabben
 *
 * == BEGIN LICENSE ==
 *
 * Licensed under the terms of any of the following licenses at your
 * choice:
 *
 *  - GNU General Public License Version 2 or later (the "GPL")
 *    http://www.gnu.org/licenses/gpl.html
 *
 *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
 *    http://www.gnu.org/licenses/lgpl.html
 *
 *  - Mozilla Public License Version 1.1 or later (the "MPL")
 *    http://www.mozilla.org/MPL/MPL-1.1.html
 *
 * == END LICENSE ==
 *
 * This is the "File Uploader" for PHP.
 */

require('./config.php') ;
require('./util.php') ;
require('./io.php') ;
require('./commands.php') ;
require('./phpcompat.php') ;

function SendError( $number, $text )
{
	SendUploadResults( $number, '', '', $text ) ;
}

// --- NetCat settings --- START
  $NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -7 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
  include_once ($NETCAT_FOLDER."vars.inc.php");
  require ($ROOT_FOLDER."connect_io.php");

  require ($ADMIN_FOLDER."auth.inc.php");
  require ($ADMIN_FOLDER."CheckUserFunctions.inc.php");

  if (!isset($AUTHORIZE_BY)) $AUTHORIZE_BY = 'User_ID';

  $user = Authorize();

  if (!$user) {
  	SendError( 1, 'Not enough rights or Hack attempt!' ) ;
  	exit;
  }

  $permTmp = $perm;

  ### check Guest
  if ( $permTmp->isGuest() ) {
  	SendError( 1, 'Not enough rights Not enought rightsor Hack attempt!' ) ;
  	exit;
  }

  $perm_count = $db->get_var("SELECT COUNT(*) FROM `Permission`");

  ### check Site, Sub, Sub_Class
  $ReturnValue = 0;
  for ($i=0; $i < $perm_count; $i++) {
  	if ( ($permTmp->ARRAY[CATALOGUE_ADMIN][$i][2] & 32) || ($permTmp->ARRAY[CATALOGUE_ADMIN][$i][2] & 16) || ($permTmp->ARRAY[CATALOGUE_ADMIN][$i][2] & 4) || ($permTmp->ARRAY[CATALOGUE_ADMIN][$i][2] & 2) || ($permTmp->ARRAY[SUBDIVISION_ADMIN][$i][2] & 32) || ($permTmp->ARRAY[SUBDIVISION_ADMIN][$i][2] & 16) || ($permTmp->ARRAY[SUBDIVISION_ADMIN][$i][2] & 4) || ($permTmp->ARRAY[SUBDIVISION_ADMIN][$i][2] & 2) || ($permTmp->ARRAY[SUB_CLASS_ADMIN][$i][2] & 32) || ($permTmp->ARRAY[SUB_CLASS_ADMIN][$i][2] & 16) || ($permTmp->ARRAY[SUB_CLASS_ADMIN][$i][2] & 4) || ($permTmp->ARRAY[SUB_CLASS_ADMIN][$i][2] & 2)) {
  		$ReturnValue = 1;
  		break;
  	}
  }

  ### check SuperRights
  if (!$ReturnValue && !$permTmp->isSupervisor() && !$permTmp->isManager() && !$permTmp->isDirector()) {
    SendError( 1, 'Not enough rights or Hack attempt!' ) ;
    exit;
  }
// --- NetCat settings --- END

// Check if this uploader has been enabled.
if ( !$Config['Enabled'] )
	SendUploadResults( '1', '', '', 'This file uploader is disabled. Please check the "editor/filemanager/connectors/php/config.php" file' ) ;

$sCommand = 'QuickUpload' ;

// The file type (from the QueryString, by default 'File').
$sType = isset( $_GET['Type'] ) ? $_GET['Type'] : 'File' ;

$sCurrentFolder	= GetCurrentFolder() ;

// Is enabled the upload?
if ( ! IsAllowedCommand( $sCommand ) )
	SendUploadResults( '1', '', '', 'The ""' . $sCommand . '"" command isn\'t allowed' ) ;

// Check if it is an allowed type.
if ( !IsAllowedType( $sType ) )
    SendUploadResults( 1, '', '', 'Invalid type specified' ) ;


FileUpload( $sType, $sCurrentFolder, $sCommand );

?>
