<?php
/* $Id: CheckUserFunctions.inc.php 2467 2008-12-06 13:51:00Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");

require_once ($ADMIN_FOLDER.'consts.inc.php');
require_once ($ADMIN_FOLDER.'auth.inc.php');
require_once ($ADMIN_FOLDER.'user.inc.php');
require_once ($ADMIN_FOLDER.'sub_class.inc.php');
require_once ($ADMIN_FOLDER.'subdivision.inc.php');
require_once ($ADMIN_FOLDER.'mail.inc.php');


/**
  *     
  * @return array Element[English.php] = English 
  */
function Language_Show() {
  global $ADMIN_FOLDER;
  if ($handle = opendir($ADMIN_FOLDER."lang")) {
    $lang=array();
    while (false !== ($file = readdir($handle))) {
      if (strlen($file)>4) {
        $name=explode(".", $file);
        $lang[$file]=$name[0];
      }
    }
    closedir($handle);
    return($lang);
  } else {
    return(false);
  }
}


function NetCat_language_detect($lang='') {
	global $_SERVER, $ADMIN_LANGUAGE;

  $langtable = array(
    'af' => 'Afrikaans',
    'sq' => 'Albanian',
    'ar' => 'Arabic',
    'hy' => 'Armenian',
    'as' => 'Assamese',
    'az' => 'Azeri',
    'eu' => 'Basque',
    'be' => 'Belarusian',
    'bn' => 'Bengali',
    'bg' => 'Bulgarian',
    'ca' => 'Catalan',
    'zh' => 'Chinese',
    'hr' => 'Croatian',
    'cs' => 'Chech',
    'da' => 'Danish',
    'div' => 'Divehi',
    'nl' => 'Dutch',
    'en' => 'English',
    'et' => 'Estonian',
    'fo' => 'Faeroese',
    'fa' => 'Farsi',
    'fi' => 'Finnish',
    'fr' => 'French',
    'mk' => 'FYRO Macedonian',
    'gd' => 'Gaelic',
    'ka' => 'Georgian',
    'de' => 'German',
    'el' => 'Greek',
    'gu' => 'Gujarati',
    'he' => 'Hebrew',
    'hi' => 'Hindi',
    'hu' => 'Hungarian',
    'is' => 'Icelandic',
    'id' => 'Indonesian',
    'it' => 'Italian',
    'ja' => 'Japanese',
    'kn' => 'Kannada',
    'kk' => 'Kazakh',
    'kok' => 'Konkani',
    'ko' => 'Korean',
    'kz' => 'Kyrgyz',
    'lv' => 'Latvian',
    'lt' => 'Lithuanian',
    'ms' => 'Malay',
    'ml' => 'Malayalam',
    'mt' => 'Maltese',
    'mr' => 'Marathi',
    'mn' => 'Mongolian',
    'ne' => 'Nepali',
    'no' => 'Norwegian',
    'or' => 'Oriya',
    'pl' => 'Polish',
    'pt' => 'Portuguese',
    'pa' => 'Punjabi',
    'rm' => 'Rhaeto-Romanic',
    'ro' => 'Romanian',
    'ru' => 'Russian',
    'sa' => 'Sanskrit',
    'sr' => 'Serbian',
    'sk' => 'Slovak',
    'ls' => 'Slovenian',
    'sb' => 'Sorbian',
    'es' => 'Spanish',
    'sx' => 'Sutu',
    'sw' => 'Swahili',
    'sv' => 'Swedish',
    'syr' => 'Syriac',
    'ta' => 'Tamil',
    'tt' => 'Tatar',
    'te' => 'Telugu',
    'th' => 'Thai',
    'ts' => 'Tsonga',
    'tn' => 'Tswana',
    'tr' => 'Turkish',
    'uk' => 'Ukrainian',
    'ur' => 'Urdu',
    'uz' => 'Uzbek',
    'vi' => 'Vietnamese',
    'xh' => 'Xhosa',
    'yi' => 'Yiddish',
    'zu' => 'Zulu'
  );
  
	#    	
	if($lang) return $langtable[$lang];

  #    
	$userlang = strtolower($_SERVER["HTTP_ACCEPT_LANGUAGE"]);
  $userlang = explode(",", $userlang);

  $langs=array();
  foreach($userlang as $key=>$val) {
    $i=substr($val, 0, 2);
    $langs[$i]=$langtable[$i];
  }

  $nclang=Language_Show();

  foreach($langs as $key=>$val) {
    if (in_array($val, $nclang, true)) {
        return($ADMIN_LANGUAGE);
    }
  }

  return false;
}


function  Unauthorize () {
  global $HTTP_HOST, $EDIT_DOMAIN, $AUTHORIZATION_TYPE;
  global $PHP_AUTH_USER, $PHP_AUTH_PW, $_SERVER, $PHP_AUTH_LANG, $PHP_AUTH_SID;
  global $PHPSESSID, $MODULE_VARS;
  global $db;
  
  if ( $sname = session_name() ) global $$sname;
    
  switch (true) {
    // cookie
    case $AUTHORIZATION_TYPE=='cookie':
      $EditDomainHost = substr($EDIT_DOMAIN,0,strlen($EDIT_DOMAIN)-strlen(strchr($EDIT_DOMAIN,"/")));
      $db->query("DELETE FROM `Session` WHERE `Session_ID` = '".$PHP_AUTH_SID."' OR `SessionTime` < '".time()."'");
      // unset back-end and front-end cookies
      $cookie_domain = $HTTP_HOST;
      setcookie ("PHP_AUTH_SID", NULL, NULL, "/", $cookie_domain);
      setcookie ("PHP_AUTH_LANG", NULL, NULL, "/", $cookie_domain);
      $cookie_domain = str_replace("www.", "", $HTTP_HOST);
      setcookie ("PHP_AUTH_SID", NULL, NULL, "/", $cookie_domain);
      setcookie ("PHP_AUTH_LANG", NULL, NULL, "/", $cookie_domain);
    break;
    // http
    case $AUTHORIZATION_TYPE=='http':
      unset($_SERVER['PHP_AUTH_USER']);
      unset($_SERVER['PHP_AUTH_PW']);
      unset($_SERVER['HTTP_AUTHORIZATION']);
    break;
    // session
    case $AUTHORIZATION_TYPE=='session':
      if ($$sname != "")
      {
        $db->query("DELETE FROM Session WHERE Session_ID = '".$$sname."' OR SessionTime < ".time());
          $$sname = $_POST['$sname'];
          $$sname = $_GET['$sname'];
      }
      session_start();
      unset($_SESSION['User']);
      session_destroy();
    break;
  }
}

function LoginFormHeader () {
  ?><!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional'>
<html>
  <head>
  <meta http-equiv='content-type' content='text/html; charset=<?=MAIN_ENCODING?>'/>
  <style type='text/css'>
    body {
      margin:0px;
      padding:0px;
      background:#FFF;
      font-size:70%;
      font-family:verdana;
      overflow:hidden;
    }
    a {
      color:#FFF;
    }
    a.relogin {
      color:#3C7EA4;
    }
    div.top_line, div.bottom_line {
      position:absolute;
      padding:10px;
      width:100%;
      color:#FFF;
      background:#3C7EA4;
      text-align:center;
      font-weight:bold;
    }
    div.top_line {
      top:0;
    }
    div.bottom_line {
      bottom:0;
    }
    table {
      font-size:100%
    }
    td {
      text-align:left;
    }
  </style>
  <title>NetCat</title>
  </head>
  <body>
    <div class='top_line'>
      <?=CONTROL_AUTH_HTML_CMS?> <a href="http://www.netcat.ru">NetCat</a>
    </div>
    <div style='overflow:hidden;position:absolute; top:40%; width:100%' align='center'>
  <?php
}

function LoginFormFooter () {
  ?>
    </div>
    <div class='bottom_line'>
      &copy; 1999<?=date("Y")?> <a href='http://www.aist.ru'><?=ENDHTML_AIST?></a>
    </div>
  </body>
</html>
  <?php
}


/**
  *    
  */
function LoginForm () {
  global $REQUEST_URI, $AUTH_USER, $ADMIN_LANGUAGE, $ADMIN_TEMPLATE;
  global $posting, $USER_LANG, $ADMIN_AUTHTYPE, $AUTHORIZATION_TYPE;

  ?>
  <script type='text/javascript'>
    function authCheckFields () {
      var authForm = document.getElementById('AUTH_FORM');
      var login = document.getElementById('AUTH_USER');
      var pass = document.getElementById('AUTH_PW');
      
      switch (true) {
        case (login.value == '' && pass.value == ''):
          alert('<?=CONTROL_AUTH_FIELDS_NOT_EMPTY?>');
        break;
        case (login.value == ''):
          alert('<?=CONTROL_AUTH_LOGIN_NOT_EMPTY?>');
        break;
        default:
          authForm.submit();
      }
    }
  </script>
  <form action='<?=$REQUEST_URI?>' method='post' name='AUTH_FORM' id='AUTH_FORM'>
	<input type='hidden' name='AuthPhase' value='1'>
	<table border='0' cellpadding='4' cellspacing='0'>
  <tr>
	<td><?=CONTROL_AUTH_HTML_LOGIN?></td>
	<td><input type='text' name='AUTH_USER' id='AUTH_USER' size='32' maxlength='255' value='<?=htmlspecialchars( stripcslashes($AUTH_USER) )?>'></td>
	</tr>
	<tr>
	<td><?=CONTROL_AUTH_HTML_PASSWORD?></td>
	<td><input type='password' name='AUTH_PW' id='AUTH_PW' size='32' maxlength='32'></td>
	</tr>
	<tr>
	<td><?=CONTROL_AUTH_HTML_LANG?></td>
	<td>
	<select name='NEW_AUTH_LANG' style='width:100%'>
  <?php
  
  $lang = Language_Show();

  if ($_COOKIE['PHP_AUTH_LANG']) {
    $sellang = $_COOKIE['PHP_AUTH_LANG'];
  }
  else {
    $sellang = $ADMIN_LANGUAGE;
  }

  foreach($lang AS $val) {
    echo "<option value='".$val."'".($val==$sellang ? " selected" : "").">".$val."</option>\n";
  }
  
  ?>
  </select>
  </td>
	</tr>

  
  <tr>
		<?=($ADMIN_AUTHTYPE == 'manual' && $AUTHORIZATION_TYPE == 'cookie' ? "<td rowspan='2'>" : "<td>")?>
    <?php
      if ( !($_REQUEST['AUTH_USER'] || $_REQUEST['AUTH_PW']) ) {
        echo "<img src='".$ADMIN_TEMPLATE."img/i_netcat_big.gif' width='32' height='32' alt='NetCat' title='NetCat'/>";
      }
      else {
        echo "<img src='".$ADMIN_TEMPLATE."img/status_error.gif' width='32' height='32' alt='".CONTROL_AUTH_LOGIN_OR_PASSWORD_INCORRECT."' title='".CONTROL_AUTH_LOGIN_OR_PASSWORD_INCORRECT."'/>";
      }
    ?>
    </td>
  <?php
  if ($ADMIN_AUTHTYPE == 'manual' && $AUTHORIZATION_TYPE == 'cookie') {
		echo "<td><label><input type='checkbox' name='loginsave'/>&nbsp;".CONTROL_AUTH_HTML_SAVELOGIN."</label></td>".
      "</tr>".
      "<tr>";
  }
  ?>
	<td>
	<input type='submit' value='<?=CONTROL_AUTH_HTML_AUTH?>' onclick='authCheckFields(); return false;'>
  <?php
  
  if ($posting && $REQUEST_URI!=$REQUESTED_FROM) {
    echo "<br/><a href='".$REQUESTED_FROM."' class='relogin'>".CONTROL_AUTH_HTML_BACK."</a>";
  }

  ?>
  </td>
	</tr>
  </table>
	</form>
  <?php
}

function Refuse ()
{
    global $db, $ADMIN_FOLDER;
    global $AUTH_TYPE, $AUTH_LANG, $PHP_AUTH_LANG, $_SESSION, $ADMIN_LANGUAGE;
    global $NOT_AUTHORIZE_MESSAGE;
    global $admin_mode;

    if (preg_match("/^\w+$/",$AUTH_LANG))
    {
        require_once($ADMIN_FOLDER."lang/".$AUTH_LANG.".php");
    }
    elseif (preg_match("/^\w+$/", $PHP_AUTH_LANG))
    {
        require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
    }
    elseif (preg_match("/^\w+$/", $_SESSION['User']['PHP_AUTH_LANG']))
    {
        require_once($ADMIN_FOLDER."lang/".$_SESSION['User']['PHP_AUTH_LANG'].".php");
    }
    else
    {
        if (!$PHP_AUTH_LANG)
        {
            $PHP_AUTH_LANG=NetCat_language_detect();
        }

        if ($PHP_AUTH_LANG)
        {
            require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
        }
        else
        {
            require_once($ADMIN_FOLDER."lang/".$ADMIN_LANGUAGE.".php");
        }
    }

    if ($_POST["NC_HTTP_REQUEST"] || NC_ADMIN_ASK_PASSWORD===false) // AJAX call
    {
       // issue strange header (actually not RFC2616-compliant) and die
       header($_SERVER['SERVER_PROTOCOL']." 401 Authorization Required");
       exit;
    }

    switch ($AUTH_TYPE)
    {
        case 'cookie':
            if (!$admin_mode)
            {
                UserLoginForm ();
            }
            else
            {
                LoginFormHeader();
                LoginForm ();
                LoginFormFooter();
            }
            break;

        case 'session':
            if (!$admin_mode)
            {
                UserLoginForm ();
            }
            else
            {
                LoginFormHeader();
                LoginForm ();
                LoginFormFooter();
            }
            break;

        default :
            #    'http'
            Header ("WWW-authenticate:  basic  realm=Enter your login and password");
            Header ($_SERVER['SERVER_PROTOCOL'].' 401  Unauthorized');
            LoginFormHeader();
            print CONTROL_AUTH_MSG_MUSTAUTH;
            LoginFormFooter();
            end;
    }
    exit;
}

function Authorize ($IsInAdmin = 0)
{
	$sname = session_name();
	global $PHP_AUTH_USER, $PHP_AUTH_PW, $PHP_AUTH_LANG,$PHP_AUTH_SID;
	global $AUTH_USER_ID, $AUTH_USER_GROUP;
	global $AUTH_USER, $AUTH_PW, $AUTH_LANG;
	global $AUTHORIZATION_TYPE;
	global $EDIT_DOMAIN, $AUTH_TYPE, $HTTP_HOST;
	global $db, $SUB_FOLDER;
	global $perm, $AuthPhase, $admin_mode;
	global $AUTHORIZE_BY, $MODULE_VARS;
	global $$sname, $ADMIN_AUTHTIME, $ADMIN_AUTHTYPE;
	
	$AUTH_TYPE = $AUTHORIZATION_TYPE;    
	$AUTH_USER_ID = 0;
	$AUTH_USER_GROUP = 0;
	
	
	// SESSION  
	if ($AUTH_TYPE == 'session') {
		if ($$sname) {
			$_GET[session_name()]  = $$sname;
      $_POST[session_name()] = $$sname;
		}
		else {
			$session_id = md5(uniqid(rand(), 1));
      session_id($session_id);
		}
		
		session_start();
    
		if ($_SESSION['User']['IsLogin'] == "1") {
			if ($_SESSION['User']['IP'] != getenv("REMOTE_ADDR")) header ("Location: ".$SUB_FOLDER."/");
			if ((time()-$_SESSION['User']['datetime']) > ini_get('session.gc_maxlifetime')) unset($_SESSION['User']);
		}
    
		$_SESSION['User']['datetime'] = time();
		$PHP_AUTH_USER = $_SESSION['User']['PHP_AUTH_USER'];
		$PHP_AUTH_PW   = $_SESSION['User']['PHP_AUTH_PW'];
		$PHP_AUTH_LANG = $_SESSION['User']['PHP_AUTH_LANG'];
	}

	
	//  () || HTTP 
	if ($AuthPhase || $AUTH_TYPE == 'http') {
		if ($AUTH_TYPE != 'http') {
			$PHP_AUTH_USER = $AUTH_USER;
			$PHP_AUTH_PW   = $AUTH_PW;
			$PHP_AUTH_LANG = $AUTH_LANG;
		}
		$result = $db->get_row("SELECT `User_ID`, `Password`, `PermissionGroup_ID`, `Language`, `".$AUTHORIZE_BY."`, `InsideAdminAccess`, `Catalogue_ID`
			FROM `User`
			WHERE `".$AUTHORIZE_BY."` = '".$PHP_AUTH_USER."' AND `Password` = PASSWORD('".$PHP_AUTH_PW."') AND `Checked` = 1", ARRAY_A);
	
	
	} // SESSION 
	else {
    $_session_id = ( $AUTH_TYPE=='session' ? $$sname : ($AUTH_TYPE=='cookie' ? $PHP_AUTH_SID : "") );
    if ($_session_id) {
      $result = $db->get_row("SELECT u.`User_ID`, u.`Password`, u.`PermissionGroup_ID`, u.`Language`, u.`".$AUTHORIZE_BY."`, s.`LoginSave`, u.`InsideAdminAccess`, u.`Catalogue_ID`
        FROM `User` AS u 
        RIGHT JOIN `Session` AS s ON u.`User_ID` = s.`User_ID`
        WHERE u.`Checked` = 1 AND u.`User_ID` != 0 AND s.`Session_ID` = '".$_session_id."' AND s.`SessionTime` > '".time()."'", ARRAY_A);
    }
  }
	
	if (!$result) {
		if ($admin_mode || $AUTH_TYPE == "http") {
			Refuse();
		}
		else {
			return false;
		}
	}
  
	$UserID            = $result['User_ID'];
	$Password          = $result['Password'];
	$UserGroup         = $result['PermissionGroup_ID'];
	$Language          = $result['Language'];
	$PHP_AUTH_USER     = $result[$AUTHORIZE_BY];
	$LoginSave         = ($result['LoginSave'] || $ADMIN_AUTHTYPE == 'always' ? 1 : 0);
	$InsideAdminAccess = $result['InsideAdminAccess'];
	$Catalogue_ID      = $result['Catalogue_ID'];

	
	//   
	if ($AUTH_TYPE != 'http') $PHP_AUTH_PW = $Password;
	if ($Language) $AUTH_LANG = $PHP_AUTH_LANG = $Language;
	
	
	if ($AUTH_TYPE != 'http') {
		$SessionStart = time();
		$SessionTime = ($ADMIN_AUTHTIME ? $SessionStart + $ADMIN_AUTHTIME : $SessionStart + 24 * 3600);
		$UserIP = sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));
	}
	
	
	
  switch (true) {
    // SESSION /
  	case $AUTH_TYPE == 'session':
  		if ($AuthPhase) {
  			$OldSid = ($$sname ? $$sname : session_id());
  			$db->query("DELETE FROM `Session` WHERE `SessionTime` < '".$SessionStart."'".($OldSid ? " OR `Session_ID` = '".$OldSid."'" : "") );
  			
  			$db->query("INSERT INTO `Session` (`Session_ID`, `User_ID`, `SessionStart`, `SessionTime`, `UserIP`, `LoginSave`, `Catalogue_ID`)
          VALUES ('".$$sname."', '".$UserID."', '".$SessionStart."', '".$SessionTime."', '".$UserIP."', '".$LoginSave."', '".$Catalogue_ID."')");
  		}
  		else {
  			$db->query("UPDATE `Session` SET `SessionTime` = '".$SessionTime."' WHERE `Session_ID` = '".$$sname."'");
  		}
  		
  		$_SESSION['User']['ID']            = $UserID;
  		$_SESSION['User']['PHP_AUTH_USER'] = $PHP_AUTH_USER;
  		$_SESSION['User']['PHP_AUTH_PW']   = $Password;
  		$_SESSION['User']['PHP_AUTH_LANG'] = $PHP_AUTH_LANG;
  		$_SESSION['User']['datetime']      = $SessionStart;
  		$_SESSION['User']['IsLogin']       = "1";
  		$_SESSION['User']['IP']            = $_SERVER['REMOTE_ADDR'];
  	break;  	
  	
    // COOKIE /
  	case $AUTH_TYPE == 'cookie':
  		if ($AuthPhase) {
  			$OldSid = ($PHP_AUTH_SID ? $PHP_AUTH_SID : $$sname);
  			$db->query("DELETE FROM `Session` WHERE `SessionTime` < '".$SessionStart."'".($OldSid ? " OR `Session_ID` = '".$OldSid."'" : ""));
  			$LoginSave = ($_POST['loginsave'] || $ADMIN_AUTHTYPE == "always" ? 1 : 0);
  			
  			$PHP_AUTH_SID = ($$sname ? $$sname : md5(uniqid(rand(), 1)));
  			$result = $db->query("INSERT INTO `Session` (`Session_ID`, `User_ID`, `SessionStart`, `SessionTime`, `UserIP`, `LoginSave`, `Catalogue_ID`)
          VALUES ('".$PHP_AUTH_SID."', '".$UserID."', '".$SessionStart."', '".$SessionTime."', '".$UserIP."', '".$LoginSave."', '".$Catalogue_ID."')");
  		}
  		// 
  		else {
  			$db->query("UPDATE `Session` SET `SessionTime` = '".$SessionTime."', `UserIP` = '".$UserIP."' WHERE `Session_ID` = '".$PHP_AUTH_SID."'");
  		}
  		
  		if (!$LoginSave) $SessionTime = 0;
  		$cookie_domain = ($MODULE_VARS['auth']['COOKIES_WITH_SUBDOMAIN'] ? str_replace("www.", "", $HTTP_HOST) : NULL);
  		setcookie('PHP_AUTH_SID',  $PHP_AUTH_SID,  $SessionTime, "/", $cookie_domain);
  		setcookie('PHP_AUTH_LANG', $PHP_AUTH_LANG, $SessionTime, "/", $cookie_domain);
  	break;
  	
    // HTTP
  	case $AUTH_TYPE == 'http':
  		end;
  	break;
  	
  	case $admin_mode || $AUTHORIZATION_TYPE == "http":
  		Refuse();
  	break;
    
    default:
      return false;
  }

	$AUTH_USER_ID    = $UserID;
	$AUTH_USER_GROUP = $UserGroup;
	
	$perm = new Permission ($UserID);
	if ($InsideAdminAccess == '0') $perm->InsideAdminAccessDeny = 1;
	
	return ($UserID);
}

function CheckUserRights ($SubClassID, $action, $posting) {
  global $db;
  global $perm;
  #  action
  #   1 - read
  #   2 - add
  #   4 - change
  #   8 - subscribe
  #  16 - moderate

  if (!$perm) Authorize();
  if (!is_object($perm)) return 0;
 
  if ( $perm->isSupervisor() ) {
      return 1;
  }


  switch ($action) {
    case "read":
      $mask = MASK_READ | MASK_MODERATE; //moderator can read all
      break;
    case "comment":
      $mask = MASK_COMMENT;
      break;
    case "add":
      $mask = MASK_ADD | MASK_MODERATE; //moderator can add
      break;
    case "change":
      $mask = MASK_EDIT | MASK_MODERATE;;
      break;
    case "subscribe":
      $mask = MASK_SUBSCRIBE;
      break;
    case "moderate":
      $mask = MASK_MODERATE;
      break;
    default:
      $mask = MASK_READ | MASK_MODERATE;
      break;
  }

  if ( $perm->isGuest() ) { //  
      if ($posting == 0 || $mask == 1) { //     
        return 1;
      }
      else {
        return 0;  
      }
  }


  #,  
  //,     
  if ( $SubClassID)
    return $perm->isSubClass ($SubClassID, $mask, true);
  
  //  ,     ,     
  //    .  
  global $current_sub;
  return $perm->isSubdivision($current_sub['Subdivision_ID'], $mask);
   
}

?>