<?php
/* $Id: admin.inc.php 2349 2008-11-05 20:57:52Z denis $ */

/**
  *   ,    
  *  (netcat/admin, netcat -  ).
  */

/**
  *    JSON
  * @param array
  * @return string
  */

function nc_array_json($array)
{
   // isn't it an associative array? [guess]
   $array_keys = array_keys($array);
   sort($array_keys);
   $array_is_numeric = ($array_keys[0]=="0" ? true : false);

   $ret_values = array();
   foreach ($array as $k=>$v)
   {
     if (is_object($v)) { continue; } //  ,  
     elseif (is_array($v)) { $v = nc_array_json($v); }
     elseif (is_bool($v)) { $v = $v ? 'true' : 'false'; }
     elseif (!is_numeric($v)) { $v = "\"".addcslashes($v, '"')."\""; }

     if ($array_is_numeric)
       { $ret_values[] = $v; }
     else
       { $ret_values[] = (is_numeric($k) ? $k : "\"".addcslashes($k, '"')."\"") . ": " . $v; }
   }

   if ($array_is_numeric) { return "[" . join(", ",  $ret_values) . "]"; }

   return "{" . join(", ",  $ret_values) . "}";
}

/**
  * ,         json
  */
class ui_config {
  /**
    *  . mainView.currentSettings
    */
  var $headerText;
  var $headerImage;
  var $tabs = array();
  var $toolbar = array();
  var $actionButtons = array();
  var $activeTab;
  var $activeToolbarButtons;
  var $treeMode;
  var $treeSelectedNode;
  var $treeChanges;
  var $locationHash;

  /**
    * 
    * @param array  (-)
    */
  function ui_config($config_array=array()) {
    foreach ($config_array as $k=>$v) {
      $this->$k = $v;
    }
  }

  /**
    *     json  <script>parent.mainView.updateSettings()</script>
    */
  function to_json() {
    $ret = get_object_vars($this);
    $ret['tabsCrc'] = crc32(serialize($ret['tabs']));
    $ret['toolbarCrc'] = crc32(serialize($ret['toolbar']));
    $ret['actionButtonsCrc'] = crc32(serialize($ret['actionButtons']));
    return "<script>if (parent && parent.mainView) { parent.mainView.updateSettings(".nc_array_json($ret)."); }</script>\n";
  }
} // of class ui_config


/**
  *     ui_config_subdivision, ...
  */
class ui_subdivision_data {
  var $catalogue_id;
  var $subdivision_id;
  var $subdivision_name;
  var $subdivision_url;
  var $subdivision_checked;

  // private
  var $subclasses = array();
  var $moderated_subclasses = array();
  var $administered_subclasses = array();
  var $is_subdivision_admin = false;

  /**
    *      id 
    * @param integer
    */
  function fetch_by_subdivision_id($sub_id) {
    settype($sub_id, 'integer');
    if (!$sub_id) return;

    $qry = "SELECT sc.Sub_Class_ID,
                   sc.Sub_Class_Name,
                   sc.Subdivision_ID,
                   sc.Class_ID,
                   sd.Subdivision_Name,
                   sd.Catalogue_ID,
                   sd.Hidden_URL,
                   sd.Checked
              FROM Sub_Class as sc,
                   Subdivision as sd
             WHERE sc.Subdivision_ID = $sub_id
               AND sc.Subdivision_ID = sd.Subdivision_ID
             ORDER BY sc.Priority";
    $this->fetch_by_query($qry);

    //     
    if (!$this->subdivision_id) {
      global $db;
      $sub_data = $db->get_row("SELECT Subdivision_ID, Subdivision_Name, Catalogue_ID, Hidden_URL, Checked
                                  FROM Subdivision
                                 WHERE Subdivision_ID = $sub_id", ARRAY_A);

      $this->catalogue_id = $sub_data['Catalogue_ID'];
      $this->subdivision_id = $sub_data['Subdivision_ID'];
      $this->subdivision_name = $sub_data['Subdivision_Name'];
      $this->subdivision_url = $sub_data['Hidden_URL'];
      $this->subdivision_checked = $sub_data['Checked'];

      $this->check_rights();
    }
  }

  /**
    *      id   
    * @param integer
    */
  function fetch_by_subclass_id($cc_id) {
    settype($cc_id, 'integer');
    $qry = "SELECT sc.Sub_Class_ID,
                   sc.Sub_Class_Name,
                   sc.Subdivision_ID,
                   sc.Class_ID,
                   sd.Subdivision_Name,
                   sd.Catalogue_ID,
                   sd.Hidden_URL,
                   sd.Checked
              FROM Sub_Class as sc,
                   Sub_Class as ref,
                   Subdivision as sd
             WHERE ref.Sub_Class_ID = $cc_id
               AND ref.Subdivision_ID = sc.Subdivision_ID
               AND sc.Subdivision_ID = sd.Subdivision_ID
             ORDER BY sc.Priority";
    $this->fetch_by_query($qry);
  }

  /**
    * '     '
    * @access private
    */
  function fetch_by_query($qry) {

    global $db;
    $this->subclasses = $db->get_results($qry, ARRAY_A);

    if ($this->subclasses[0]) {
      $this->catalogue_id = $this->subclasses[0]['Catalogue_ID'];
      $this->subdivision_id = $this->subclasses[0]['Subdivision_ID'];
      $this->subdivision_name = $this->subclasses[0]['Subdivision_Name'];
      $this->subdivision_url = $this->subclasses[0]['Hidden_URL'];
      $this->subdivision_checked = $this->subclasses[0]['Checked'];

      $this->check_rights();
    }
  }

  /**
    * Fills $administered_subclasses, $moderated_subclasses
    * @access private
    */
  function check_rights() {

    global $perm;

    // has rights for everything in the sub
    $user_is_cool = $perm->isSupervisor() || $perm->isGuest() ;


    if ($user_is_cool) {
      $this->moderated_subclasses = &$this->subclasses;
      $this->administered_subclasses = &$this->subclasses;
      $this->is_subdivision_admin = true;
      return true;
    }
    if ($perm->isSubdivisionAdmin($this->subdivision_id) ) {
      // $this->administered_subclasses = &$this->subclasses;
      $this->is_subdivision_admin = true; 
    }
    
     if ($perm->isSubdivision($this->subdivision_id, 16) ) {
      ;// $this->moderated_subclasses = &$this->subclasses;
    }
    
    
    if (!sizeof($this->subclasses)) return;

    // subclass admin / moderator
    foreach ($this->subclasses as $idx=>$sc) { 
      if ($perm->isSubclassAdmin($sc['Sub_Class_ID'])) { 
        $this->administered_subclasses[] = &$this->subclasses[$idx];
        //$this->moderated_subclasses[] = &$this->subclasses[$idx];
      }
      if ($perm->isSubclass($sc['Sub_Class_ID'], 16)) {
        $this->moderated_subclasses[] = &$this->subclasses[$idx];
      }
    }

    // subdivision moderator
    $user_is_moderator = ($perm->isCatalogue($this->catalogue_id, 16) ||
                          $perm->isSubdivision($this->subdivision_id, 16));

    if ($user_is_moderator) {
      $this->moderated_subclasses = &$this->subclasses;
    }

  }

  /**
    *      
    * @return boolean
    */
  function is_subdivision_admin() {
    return $this->is_subdivision_admin;
  }

  /**
    *      $cc_id   $cc_id  
    *          
    * @access public
    * @return boolean
    */
  function is_subclass_moderator($cc_id=0) {
    if (!$cc_id) return (sizeof($this->moderated_subclasses) ? true : false);

    foreach ((array)$this->moderated_subclasses as $sc) {
      if ($sc["Sub_Class_ID"] == $cc_id) return true;
    }
    return false;
  }

  /**
    *     [$cc_id|  ]   
    * @access public
    * @return boolean
    */
  function is_subclass_admin($cc_id=0) {
    return (sizeof($this->administered_subclasses) ? true : false);

    foreach ((array)$this->administered_subclasses as $sc) {
      if ($sc["Sub_Class_ID"] == $cc_id) return true;
    }
    return false;
  }

  /**
    *      --,  
    *   ( .. ,   )
    * @access public
    * @return array
    */
  function get_moderated_subclasses() {
    return $this->moderated_subclasses;

  }

  /**
    *      --,  
    *  
    * @access public
    * @return array
    */
  function get_administered_subclasses() {
    return $this->administered_subclasses;
  }

  /**
    *  id    ,   
    */
  function get_first_administered_subclass_id() {
    return $this->administered_subclasses[0]['Sub_Class_ID'];
  }

  /**
    *  id    ,   
    */
  function get_first_moderated_subclass_id() {
    return $this->moderated_subclasses[0]['Sub_Class_ID'];
  }

}

/**
  *      ,     
  *   ,    (
  *  )  
  */
class ui_config_subdivision_gereric extends ui_config {
  /**
    *          (ui_subdivision_data)
    */
  var $sub;

  /**
    * @param integer
    * @param integer
    */
  function init($sub_id, $cc_id=0) {
    global $perm;
    $this->sub = new ui_subdivision_data();
    if ($sub_id) { $this->sub->fetch_by_subdivision_id($sub_id); }
    elseif ($cc_id) { $this->sub->fetch_by_subclass_id($cc_id); }
    else { trigger_error("Wrong parameters for ui_config_subdivision_gereric::init", E_USER_ERROR); }

    $this->headerText = $subdivision["Subdivision_Name"];
    $this->headerImage = 'i_folder_big.gif';

    //   
    $this->tabs = array();
    
    // 1.  -     
    if ($this->sub->is_subdivision_admin() ) {
      $this->tabs[] = array('id' => 'info',
                            'caption' => STRUCTURE_TAB_INFO,
                            'location' => "subdivision.info({$this->sub->subdivision_id})"
                           );  
    }
    
    
    // 2.  -     
    if ($this->sub->is_subdivision_admin() ) {
         $this->tabs[] = array('id' => 'settings',
                            'caption' => STRUCTURE_TAB_SETTINGS,
                            'location' => "subdivision.edit({$this->sub->subdivision_id})"
                           );  
    }
    
    
    // 3.  .    .   -  .
    if ( $this->sub->is_subdivision_admin() ) {//|| $this->sub->is_subclass_admin() )
      $loc = ($this->sub->subclasses) ? "subclass.list({$this->sub->subdivision_id})" : "subclass.add({$this->sub->subdivision_id})";
      $this->tabs[] = array('id' => 'subclass',
                            'caption' => STRUCTURE_TAB_USED_SUBCLASSES,
                            'location' => $loc
                           );
    }
    else if ( $this->sub->is_subclass_admin() ) { // admin  
      $active_cc_id =  $this->sub->get_first_administered_subclass_id();
      $this->tabs[] = array('id' => 'subclass',
                            'caption' => STRUCTURE_TAB_USED_SUBCLASSES,
                            'location' => "subclass.edit(".$active_cc_id.", ".$this->sub->subdivision_id.")"
                           );
        
    }
    
    
   // if ($this->sub->is_subclass_moderator()) { //    

			//$this->tabs[] = array('id' => 'subclass',
        //                    'caption' => STRUCTURE_TAB_USED_SUBCLASSES,
          //                  'location' => "subclass.list({$this->sub->subdivision_id})"
            //               );
			// 4. 
			$active_cc_id = $this->sub->get_first_moderated_subclass_id();	
			//print $active_cc_id;
		  if ( $active_cc_id ) {	
		    						 $this->tabs[] = array('id' => 'objects',
                            'caption' => STRUCTURE_TAB_EDIT,
                            'location' => "object.list($active_cc_id)"
                           );
		  }
    //} 
   // else if ( $this->sub->is_subdivision_admin() ) {
      // TAB       
		//	$this->tabs[] = array('id' => 'subclass',
     //                       'caption' => STRUCTURE_TAB_USED_SUBCLASSES,
      //                      'location' => "subclass.add({$this->sub->subdivision_id})"
       //                    );
    //}
    
    /*
    if ($this->sub->is_subdivision_admin() || $this->sub->is_subclass_admin()) {


      // TAB 
      
      $loc = $this->sub->is_subdivision_admin()
                ? "subdivision.edit({$this->sub->subdivision_id})"
                : "subclass.edit($active_cc_id,{$this->sub->subdivision_id})";

      $this->tabs[] = array('id' => 'settings',
                            'caption' => STRUCTURE_TAB_SETTINGS,
                            'location' => $loc
                           );
    }

    $active_cc_id = $cc_id ? $cc_id : $this->sub->get_first_moderated_subclass_id();

    // TAB 
    */
    // 5. 
    $this->tabs[] = array('id' => 'view',
                          'caption' => STRUCTURE_TAB_PREVIEW,
                          'location' => $active_cc_id ? "subclass.view(0,$active_cc_id)"
                                                      : "subdivision.view({$this->sub->subdivision_id},0)"
                         );

    //   
    $this->headerImage = 'i_folder_big.gif';
    $this->headerText = $this->sub->subdivision_name;
    $this->treeMode = 'sitemap';
    $this->treeSelectedNode = "sub-". $this->sub->subdivision_id;
  }

}

class ui_config_objects extends ui_config_subdivision_gereric {

  function ui_config_objects($cc_id) {
    $this->init(0, $cc_id);
    if (!$cc_id) { trigger_error("Wrong cc_id in ui_config_objects::ui_config_objects", E_USER_ERROR); }

    $this->activeTab = 'objects';

    // 
    $subclasses = $this->sub->get_moderated_subclasses();

    if (sizeof($subclasses) > 1) {
      $enable_subclass_drag = $this->sub->is_subdivision_admin();
      foreach ($subclasses as $sc) {
        $this->toolbar[] = array('id' => "subclass$sc[Class_ID]-$sc[Sub_Class_ID]",
                                 'caption' => $sc["Sub_Class_Name"],
                                 'location' => "object.list($sc[Sub_Class_ID])",
                                 'group' => "grp1",
                                 'acceptDropFn' => 'subclassAcceptDrop',
                                 'onDropFn' => 'subclassOnDrop',
                                 'dragEnabled' => $enable_subclass_drag,
                                 'metadata' => array("subdivisionId"=>$sc['Subdivision_ID'])
                                );
        $cc_subs[$sc["Sub_Class_ID"]] = $sc["Class_ID"];
      }

      $this->activeToolbarButtons[] = "subclass{$cc_subs[$cc_id]}-$cc_id";
    }

  }

}

/**
  * 
  */
class ui_config_tool extends ui_config {

  /**
    * @param string  
    * @param string     
    * @param string  (#)
    */
  function ui_config_tool($name, $caption, $big_icon, $location) {
    $this->headerText = $name;
    $this->headerImage = $big_icon;
    $this->tabs = array(array("id"=>"tool", "caption"=>$caption, "location"=>$location));
    $this->activeTab = "tool";
    $this->locationHash = $location;
  }
}

/**
  *   URL       netcat-admin.
  * : ob_start("nc_postprocess_admin_page").
  * :
  * -  inside_iframe       
  *   (..     2.4  )
  * @return string 
  */
function nc_postprocess_admin_page($str) {
  if (!strlen($str)) return "";

  global $inside_admin, $HTTP_ROOT_PATH, $SUB_FOLDER;
  if (!$inside_admin) return $str;

  global $parsed_url; //  

	$local_links_re = "(                            # $1: whole link
		(                               			# $2: script path
			(?:                           			# group: absolute path
				(?:
					".$parsed_url['scheme']." ://  	# protocol
					".$parsed_url['host']."        	# host
					(?::".$parsed_url['port'].")? 	# port
				)?                         			# host part is optional
				".$SUB_FOLDER.$HTTP_ROOT_PATH." 	# /netcat/
				(?!admin/)                 			# but not /netcat/admin/
			)?                            			# optional (relative path)
			(?:[^/?#][^?#'\"\s>]*)?        			# script name (optional)
		)                               			# grab path
		(?:\?([^'\"\s>]+))?            				# followed by GET params ($3)
	)";

  // look for forms and hrefs
  preg_match_all("@
                   <(?:a|form) \s
                   [^>]*
                   (?:href|action)\s*=\s*[\"']?{$local_links_re}[\"']?
                   [^>]*
                   >
                  @xs", $str, $regs, PREG_PATTERN_ORDER);

  // regs[1] - full link; [2] path; [3] get params

  foreach ($regs[3] as $num=>$get_params) {
    if (!$get_params || !preg_match("/[?&]inside_admin=/", $get_params)) {
      $new_link = str_replace($regs[1][$num],
                              $regs[2][$num] . "?inside_admin=$inside_admin" . ($get_params ? "&$get_params" : ""),
                              $regs[0][$num]);
      $str = str_replace($regs[0][$num], $new_link, $str);
    }
  }

  return $str;
}


/**
 *   
 *
 * @param string $message  
 * @param string $status   
 * @param array $array    
 *
 * @return bool   true
 */
function nc_print_status($message, $status, $array = '') {
	if ($array) {
		vprintf("<div id='statusMessage' class='status_".$status."'>".$message."</div>\n", $array);
	} else {
		print "<div id='statusMessage' class='status_".$status."'>".$message."</div>\n";
	}
	return true;
}


/**
  *         .
  *
  *    :   , 
  *  ,    ,   .
  *
  * @param integer ID  
  * @param integer ID 
  * @param integer ID   ,   
  * @return boolean
  */
function nc_move_message($class_id, $message_id, $destination_cc_id) {
  $class_id = (int)$class_id;
  $message_id = (int)$message_id;
  $destination_cc_id = (int)$destination_cc_id;

  if (!$class_id || !$message_id || !$destination_cc_id) {
    trigger_error("Wrong parameters for nc_move_message()", E_USER_WARNING);
    return false;
  }

  global $db;

  //        
  $message = $db->get_row("SELECT sd.Catalogue_ID,
                                  m.Subdivision_ID,
                                  m.Sub_Class_ID,
                                  m.Priority
                             FROM Message{$class_id} as m,
                                  Subdivision as sd
                            WHERE m.Message_ID=$message_id
                              AND m.Subdivision_ID=sd.Subdivision_ID
                          ", ARRAY_A);

  //    
  $dest_subclass = $db->get_row("SELECT sd.Catalogue_ID,
                                        sc.Sub_Class_ID,
                                        sc.Subdivision_ID,
                                        sc.Class_ID,
                                        IFNULL(MAX(m.Priority)+1,1) as Next_Priority
                                   FROM (Sub_Class as sc,
                                        Subdivision as sd)
                                        LEFT JOIN Message{$class_id} as m
                                          ON m.Sub_Class_ID=sc.Sub_Class_ID
                                  WHERE sc.Sub_Class_ID=$destination_cc_id
                                    AND sc.Subdivision_ID=sd.Subdivision_ID
                                  GROUP BY m.Sub_Class_ID
                                  ", ARRAY_A);

  if (!$message || !$dest_subclass) {
    $what = ($message ? 'subclass' : 'object');
    trigger_error("nc_move_message: $what doesn't exist", E_USER_WARNING);
    return false;
  }

  if ($dest_subclass['Class_ID'] != $class_id) {
    trigger_error("nc_move_message: destination subclass belongs to different class", E_USER_WARNING);
    return false;
  }

  if ($dest_subclass['Sub_Class_ID'] == $message['Sub_Class_ID']) { return true; } // ?!

  // 
  //    :   , 
  //  ,    ,   .
  global $perm;
  $has_rights = false;

  $has_rights = ($perm->isSubClass($message['Sub_Class_ID'], 48) && $perm->isSubClass($dest_subclass['Sub_Class_ID'], 48) );


  if (!$has_rights) {
    trigger_error("nc_move_message: insufficient rights", E_USER_WARNING);
    return false;
  }

  // 
  $file_fields = $db->get_results("SELECT Field_ID FROM Field WHERE Class_ID=$class_id AND TypeOfData_ID=6", ARRAY_A);
  if (sizeof($file_fields)) {

    // prepare dirs
    global $FILES_FOLDER, $DIRCHMOD, $DOCUMENT_ROOT, $SUB_FOLDER;

    $dirs = array($FILES_FOLDER . $dest_subclass['Subdivision_ID'],
                  $FILES_FOLDER . $dest_subclass['Subdivision_ID'] . '/' . $dest_subclass['Sub_Class_ID']);

    foreach ($dirs as $dir) {
      if (!file_exists($dir) && !mkdir($dir, $DIRCHMOD)) { return false; } // can't create dir
    }

    $dest_path = "/$dest_subclass[Subdivision_ID]/$dest_subclass[Sub_Class_ID]/";

    require_once($GLOBALS['INCLUDE_FOLDER'] . "s_common.inc.php");
    foreach ($file_fields as $field) {
      $file_path = nc_file_path($class_id, $message_id, $field['Field_ID']);
      // if 2.3-style storage is used [fieldId_messageId.ext] we've got nothing to do
      if ($file_path && preg_match("#/([0-9a-f]{32})$#i", $file_path, $regs)) { // 2.4
        if (file_exists(rtrim($DOCUMENT_ROOT, '/') . $SUB_FOLDER . $file_path) && !rename($DOCUMENT_ROOT . $SUB_FOLDER . $file_path, rtrim($FILES_FOLDER, '/') . $dest_path . $regs[1])) {
          return false;
        }
      }
      $db->query("UPDATE Filetable SET File_Path='$dest_path' WHERE Message_ID=$message_id AND Field_ID=$field[Field_ID]");
    }

  } // of "   ""

  //  
  $db->query("UPDATE Message{$class_id}
                 SET Subdivision_ID={$dest_subclass[Subdivision_ID]},
                     Sub_Class_ID={$dest_subclass[Sub_Class_ID]},
                     Priority = {$dest_subclass[Next_Priority]}
               WHERE Message_ID = {$message_id}");

  //   ''     
  $db->query("UPDATE Message{$class_id}
                 SET Created=Created, LastUpdated=LastUpdated,
                     Priority = Priority-1
               WHERE Sub_Class_ID = {$message[Sub_Class_ID]}
                 AND Priority > $message[Priority]");

  return true;
}


/**
  *         .
  *
  *    :   , 
  *  ,    ,   .
  *
  * @param integer ID  
  * @param integer ID 
  * @param integer ID   ,   
  * @return boolean
  */
function nc_copy_message($class_id, $message_id, $destination_cc_id) {
  $class_id = (int)$class_id;
  $message_id = (int)$message_id;
  $destination_cc_id = (int)$destination_cc_id;

  if (!$class_id || !$message_id || !$destination_cc_id) {
    trigger_error("Wrong parameters for nc_copy_message()", E_USER_WARNING);
    return false;
  }

  global $db;

  //    
  $dest_subclass = $db->get_row("SELECT sd.Catalogue_ID,
                                        sc.Sub_Class_ID,
                                        sc.Subdivision_ID,
                                        sc.Class_ID,
                                        IFNULL(MAX(m.Priority)+1,1) as Next_Priority
                                   FROM (Sub_Class as sc,
                                        Subdivision as sd)
                                        LEFT JOIN Message{$class_id} as m
                                          ON m.Sub_Class_ID=sc.Sub_Class_ID
                                  WHERE sc.Sub_Class_ID=$destination_cc_id
                                    AND sc.Subdivision_ID=sd.Subdivision_ID
                                  GROUP BY m.Sub_Class_ID
                                  ", ARRAY_A);

  //  
  $message = $db->get_row("SELECT * FROM Message{$class_id} WHERE Message_ID = $message_id", ARRAY_A);

  if (!$message || !$dest_subclass) {
    $what = ($message ? 'subclass' : 'object');
    trigger_error("nc_copy_message: $what doesn't exist", E_USER_WARNING);
    return false;
  }

  if ($dest_subclass['Class_ID'] != $class_id) {
    trigger_error("nc_copy_message: destination subclass belongs to different class", E_USER_WARNING);
    return false;
  }

//  if ($dest_subclass['Sub_Class_ID'] == $message['Sub_Class_ID']) { return true; } //       $cc


  // 
  //    :   , 
  //  ,    ,   .
  global $perm;
  $has_rights = false;
  
  $has_rights = ($perm->isSubClass($message['Sub_Class_ID'], 48) && $perm->isSubClass($dest_subclass['Sub_Class_ID'], 48) );

  if (!$has_rights) {
    trigger_error("nc_copy_message: insufficient rights", E_USER_WARNING);
    return false;
  } // end of 

  $message['Message_ID'] = '';

  $message['Subdivision_ID'] = $dest_subclass['Subdivision_ID'];
  $message['Sub_Class_ID'] = $dest_subclass['Sub_Class_ID'];
  $message['Priority'] = $dest_subclass['Next_Priority'];

  $col_names = array_keys($message);
  $col_names_string = join(", ", $col_names);
	
  $col_values = array_values($message);
  $col_values_string = join("', '", $col_values);
	
  $db->query("INSERT INTO Message{$class_id} (".$col_names_string.") VALUES ('".$col_values_string."')");

  $new_message_id = $db->insert_id;

  // 

  $file_fields = $db->get_results("SELECT Field_ID FROM Field WHERE Class_ID=$class_id AND TypeOfData_ID=6", ARRAY_A);

  if (sizeof($file_fields)) {

    // prepare dirs
    global $FILES_FOLDER, $DIRCHMOD, $DOCUMENT_ROOT, $SUB_FOLDER;

    $dirs = array($FILES_FOLDER . $dest_subclass['Subdivision_ID'],
                  $FILES_FOLDER . $dest_subclass['Subdivision_ID'] . '/' . $dest_subclass['Sub_Class_ID']);

    foreach ($dirs as $dir) {
      if (!file_exists($dir) && !mkdir($dir, $DIRCHMOD)) { return false; } // can't create dir
    }

    $dest_path = "/$dest_subclass[Subdivision_ID]/$dest_subclass[Sub_Class_ID]/";

    require_once($GLOBALS['INCLUDE_FOLDER'] . "s_common.inc.php");
    foreach ($file_fields as $field) {
      $file_path = nc_file_path($class_id, $message_id, $field['Field_ID']);
      // if 2.3-style storage is used [fieldId_messageId.ext] we've got nothing to do
      if ($file_path && preg_match("#/([0-9a-f]{32})$#i", $file_path, $regs)) { // 2.4
        if (file_exists(rtrim($DOCUMENT_ROOT, '/') . $SUB_FOLDER . $file_path)) {
          $file = $db->get_row("SELECT * FROM Filetable WHERE Message_ID=$message_id AND Field_ID=$field[Field_ID]", ARRAY_A);

          //     
          $uniq_file_name = md5($file['Real_Name'].date("H:i:s d.m.Y").uniqid("netcat"));
          copy($FILES_FOLDER.$file['File_Path'].$file['Virt_Name'], $FILES_FOLDER.$dest_path.$uniq_file_name);

          $file['ID'] = '';
          $file['File_Path'] = $dest_path;
          $file['Virt_Name'] = $uniq_file_name;
          $file['Message_ID'] = $new_message_id;

          $col_values = array_values($file);
          $col_values_string = join("', '", $col_values);

          $db->query("INSERT INTO Filetable (ID, Real_Name, Virt_Name, File_Path, File_Type, File_Size, Message_ID, Field_ID) VALUES ('".$col_values_string."')");
        }
      }
    }

  } // of "   ""

  return true;
}


/**
  *  --   
  */
function nc_move_subclass($subclass_id, $dest_sub_id) {
  settype($subclass_id, "integer");
  settype($dest_sub_id, "integer");
  global $db, $perm;

  $subclass = $db->get_row("SELECT Class_ID, Catalogue_ID, Subdivision_ID, Sub_Class_ID, Priority FROM Sub_Class WHERE Sub_Class_ID = $subclass_id", ARRAY_A);
  $subdivision = $db->get_row("SELECT Catalogue_ID, Subdivision_ID FROM Subdivision WHERE Subdivision_ID = $dest_sub_id", ARRAY_A);

  if (!$subclass || !$subdivision) {
    trigger_error("nc_move_subclass: wrong parameters (can't get data)", E_USER_WARNING);
    return false;
  }

  $has_rights = false;
  
  $has_rights = $perm->isSubdivisionAdmin($dest_sub_id);

  if (!$has_rights) {
    trigger_error("nc_move_subclass: insufficient rights", E_USER_WARNING);
    return false;
  }

  if ($subclass['Subdivision_ID']==$dest_sub_id) { return false; }

  // move subdivision
  $next_priority = $db->get_var("SELECT IFNULL(MAX(Priority)+1,1)
                                   FROM Sub_Class
                                  WHERE Subdivision_ID = $dest_sub_id");

  $db->query("UPDATE Sub_Class
                 SET Subdivision_ID=$dest_sub_id, Priority=$next_priority
               WHERE Sub_Class_ID=$subclass_id");

  // close gap priority at old subdivision
  $db->query("UPDATE Sub_Class
                 SET Priority=Priority-1
               WHERE Subdivision_ID = $subclass[Subdivision_ID]
                 AND Priority > $subclass[Priority]");

  // move 'messages'
  $db->query("UPDATE Message{$subclass[Class_ID]}
                 SET Subdivision_ID = $dest_sub_id
               WHERE Sub_Class_ID = $subclass_id");

  // move files
  $has_files = $db->get_var("SELECT COUNT(*)
                               FROM Filetable
                              WHERE File_Path = '/$subclass[Subdivision_ID]/$subclass[Sub_Class_ID]/'");
  if ($has_files) {
    // prepare dirs
    global $FILES_FOLDER, $DIRCHMOD;
    @mkdir($FILES_FOLDER."$dest_sub_id", $DIRCHMOD);

    // move dir
    $old_path = $FILES_FOLDER . "$subclass[Subdivision_ID]/$subclass[Sub_Class_ID]";
    $new_path = $FILES_FOLDER . "$dest_sub_id/$subclass_id";

    if (file_exists($old_path)) {
      rename($old_path, $new_path);
    }

    $db->query("UPDATE Filetable
                   SET File_Path='/$dest_sub_id/$subclass_id/'
                 WHERE File_Path='/$subclass[Subdivision_ID]/$subclass[Sub_Class_ID]/'");
  }

  return true;
}

/**
  *  (, )    textarea 
  * @param string $type   (template || class)
  * @param string $window    ,  window  opener
  * @param string $form  
  * @param string $textarea  textarea
  */
function nc_form_data_insert($type, $window, $form, $textarea) {
  global $db;
//  global $class_id, $system_class_id;

  $class_id = $_GET['classid'];
  $system_class_id = $_GET['systemclassid'];
  
  switch ($type) {
    case "class":
      if ($textarea == 'PageBody' || $textarea == 'ListBody' || $textarea == 'ListPrefix' || $textarea == 'ListSuffix' || $textarea == 'Settings') {
        if ($class_id) {
          $class_fields = $db->get_results("SELECT Field_Name, Description FROM Field WHERE Class_ID = '".$class_id."' ORDER BY Priority", ARRAY_A);
        } else {
          if ($system_class_id) $class_fields = $db->get_results("SELECT Field_Name, Description FROM Field WHERE System_Table_ID = '".$system_class_id."' ORDER BY Priority", ARRAY_A);  
        } 
        if ($textarea == 'PageBody' || $textarea == 'ListBody' || $textarea == 'Settings') {
          if ($class_fields) {
            //  
            echo "<table class='InsertDataTable'>\n";
            echo "<tr><td colspan='2'><b> </b></td></tr>";
            foreach ($class_fields as $class_field) {
              echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_".$class_field['Field_Name']."</a></td><td>".$class_field['Description']."</td></tr>\n";
            }
            echo "</table>\n<br><br>\n";
          }
        }

        // ,    
        echo "<table class='InsertDataTable'>\n";
        echo "<tr><td colspan='2'><b>,    </b></td></tr>";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_Created</a></td><td>       &laquo;-- ::&raquo;</td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_LastUpdated</a></td><td>       &laquo;&raquo;</td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_RowID</a></td><td> (ID) </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_UserID</a></td><td> (ID) ,  </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_Checked</a></td><td>    (0/1)</td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_IP</a></td><td>IP- ,  </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_UserAgent</a></td><td>  \$HTTP_USER_AGENT  ,  </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_LastUserID</a></td><td> (ID)  ,  </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_LastIP</a></td><td>IP-  ,  </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_LastUserAgent</a></td><td>  \$HTTP_USER_AGENT   ,  </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_AdminButtons</a></td><td>                &laquo;&raquo;, &laquo;&raquo;, &laquo;/&raquo; (   &laquo;  &raquo;)</td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_AdminCommon</a></td><td>                           (   &laquo;  &raquo;)</td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$fullLink</a></td><td>      </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$fullDateLink</a></td><td>          &laquo;.../2002/02/02/message_2.html&raquo; (         &laquo;  &raquo;   &laquo;event&raquo;,      \$fullLink)</td></tr>\n";
        echo "</table>\n";

        // ,     
        echo "<table class='InsertDataTable'>\n";
        echo "<tr><td colspan='2'><b>,     </b></td></tr>";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$prevLink</a></td><td>       (       ,   )</td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$nextLink</a></td><td>       (       ,   )</td></tr>\n";
        if ($textarea == 'PageBody') echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$f_RowNum</a></td><td>        </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$recNum</a></td><td>  ,   </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$totRows</a></td><td>    </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$begRow</a></td><td>  ( ),        </td></tr>\n";
        echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$endRow</a></td><td>  ( ),       </td></tr>\n";
        echo "</table>\n";
      }

      // ,     
      echo "<table class='InsertDataTable'>\n";
      echo "<tr><td colspan='2'><b>,    </b></td></tr>";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$admin_mode</a></td><td>,      </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$subHost</a></td><td>    &laquo;www.vasya.ru&raquo;</td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$subLink</a></td><td>     &laquo;/about/pr/&raquo;</td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$ccLink</a></td><td>       &laquo;news.html&raquo;</td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$catalogue</a></td><td>  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$sub</a></td><td>  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$cc</a></td><td>  </td></tr>\n";
      echo "</table>\n";

      // -
      echo "<table class='InsertDataTable'>\n";
      echo "<tr><td colspan='2'><b>-</b></td></tr>";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$current_catalogue[]</a></td><td>    </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$current_sub[]</a></td><td>    </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$current_[]</a></td><td>      </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$current_user[]</a></td><td>     .</td></tr>\n";
      echo "</table>\n";
      
      // 
      echo "<table class='InsertDataTable'>\n";
      echo "<tr><td colspan='2'><b></b></td></tr>";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">is_even(int \$param)</a></td><td>   </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">opt(\$flag, \$string)</a></td><td> opt()  \$string  ,  \$flag  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">opt_case(\$flag, \$string1, \$string2)</a></td><td> opt_case()  \$string1  ,  \$flag ,  \$string2,  \$flag </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">listQuery(char \$sql_query, char \$output_template = NULL, char \$divider = NULL)</a></td><td>    SQL- $sql_query.    SELECT (   ,  )  $output_template    . $output_template   .<br>     - $data,      (      ). $divider     .</td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">nc_list_select(\$classificator_name, \$field_name = NULL, \$current_value = NULL, \$sort_type = NULL, \$sort_direction = NULL, \$template_prefix = NULL, \$template_object = NULL, \$template_suffix = NULL, \$template_any = NULL)</a></td><td>   HTML    NetCat</td></tr>\n";
//      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">nc_mail2queue(\$recipient, \$from, \$subject, \$message)</a></td><td></td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">nc_message_link(int \$message_id, int \$class_id)</a></td><td>       ( )   (ID)     (ID) ,   </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">nc_file_path( mixed \$class_id, int \$message_id, mixed \$field_name_or_id, [string \$file_name_prefix=\"\"] )</a></td><td>     ,    ,   (ID)     (ID) ,   </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">nc_file_field(\$field_name, \$style = NULL)</a></td><td>                  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">browse_messages(\$cc_env, \$range)</a></td><td>         </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">s_list_class(int \$sub, int \$cc, char \$params, bool \$show_in_admin_mode = FALSE)</a></td><td>     \$cc  \$sub   \$params   ,      URL</td></tr>\n";
      echo "</table>\n";
    break;
    case "template":
      // ,     
      echo "<table class='InsertDataTable'>\n";
      echo "<tr><td colspan='2'><b>,    </b></td></tr>";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$catalogue</a></td><td>  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$sub</a></td><td>  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$cc</a></td><td>  </td></tr>\n";
      echo "</table>\n";

      // -
      echo "<table class='InsertDataTable'>\n";
      echo "<tr><td colspan='2'><b>-</b></td></tr>";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$current_catalogue[]</a></td><td>    </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$current_sub[]</a></td><td>    </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$current_[]</a></td><td>      </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">\$current_user[]</a></td><td>     .</td></tr>\n";
      echo "</table>\n";

      // 
      echo "<table class='InsertDataTable'>\n";
      echo "<tr><td colspan='2'><b></b></td></tr>";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">is_even(int \$param)</a></td><td>   </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">opt(\$flag, \$string)</a></td><td> opt()  \$string  ,  \$flag  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">opt_case(\$flag, \$string1, \$string2)</a></td><td> opt_case()  \$string1  ,  \$flag ,  \$string2,  \$flag </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">listQuery(char \$sql_query, char \$output_template = NULL, char \$divider = NULL)</a></td><td>    SQL- $sql_query.    SELECT (   ,  )  $output_template    . $output_template   .<br>     - $data,      (      ). $divider     .</td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">s_list_class(int \$sub, int \$cc, char \$params, bool \$show_in_admin_mode = FALSE)</a></td><td>     \$cc  \$sub   \$params   ,      URL</td></tr>\n";
      echo "</table>\n";
    break;
    
    case "classinput":
      if ($class_id) {
        $class_fields = $db->get_results("SELECT Field_Name, Description FROM Field WHERE Class_ID = '".$class_id."' ORDER BY Priority", ARRAY_A);
      } else {
        if ($system_class_id) $class_fields = $db->get_results("SELECT Field_Name, Description FROM Field WHERE System_Table_ID = '".$system_class_id."' ORDER BY Priority", ARRAY_A);  
      }
      if ($class_fields) {
        //  
        echo "<table class='InsertDataTable'>\n";
        echo "<tr><td colspan='2'><b> </b></td></tr>";
        foreach ($class_fields as $class_field) {
          echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">".$class_field['Field_Name']."</a></td><td>".$class_field['Description']."</td></tr>\n";
        }
        echo "</table>\n<br><br>\n";
      }
      echo "<table class='InsertDataTable'>\n";
      echo "<tr><td colspan='2'><b>,    </b></td></tr>";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">Created</a></td><td>       &laquo;-- ::&raquo;</td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">LastUpdated</a></td><td>       &laquo;&raquo;</td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">RowID</a></td><td> (ID) </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">UserID</a></td><td> (ID) ,  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">Checked</a></td><td>    (0/1)</td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">IP</a></td><td>IP- ,  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">UserAgent</a></td><td>  \$HTTP_USER_AGENT  ,  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">LastUserID</a></td><td> (ID)  ,  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">LastIP</a></td><td>IP-  ,  </td></tr>\n";
      echo "<tr><td><a href='#' title='' onclick=\"insert_bbcode('".$window."', '".$form."', '".$textarea."', this.innerHTML, '', false);\">LastUserAgent</a></td><td>  \$HTTP_USER_AGENT   ,  </td></tr>\n";
      echo "</table>\n<br><br>\n";
    break;
  }
}


/**
  *        
  *     $subdivision_id
  * @param int $subdivision_id  
  * @return array  
  */
function nc_get_subdivision_children($subdivision_id) {
  global $db;
  
  $parent_subs = $db->get_col("SELECT Subdivision_ID FROM Subdivision WHERE Parent_Sub_ID = $subdivision_id");
  if (!$parent_subs) return;
  foreach ($parent_subs as $parent_sub_id) {
    $parent_subs_array[] = $parent_sub_id;
	$parent_subs_array = array_merge($parent_subs_array, nc_get_subdivision_children($parent_sub_id));
  }
  
  return $parent_subs_array;
}


?>