<?php
/* $Id: catalog.inc.php 2317 2008-10-08 14:32:42Z vadim $ */


function IsCatalogueExist ($CatalogueID)
{
  global $db;

  $select = " select Catalogue_ID from Catalogue where Catalogue_ID='";
  $select .= $CatalogueID."'";

  $Result = $db->_query ($select);
  if ($db->num_rows  > 0)
     return 1;
  else
     return 0;

}


function GetDomainBySubdivisionID ($SubdivisionID)
{
 global $db;

 $select = "select Domain from Catalogue,Subdivision where Subdivision_ID='";
 $select .= $SubdivisionID."'";
 $select .= " and Subdivision.Catalogue_ID=Catalogue.Catalogue_ID";
 $ResultArray = $db->get_var($select);

 return $ResultArray;
}


function GetDomainByCatalogueID ($CatalogueID)
{
 global $db;
 @$Array = $db->get_var("select Domain from Catalogue where Catalogue_ID='".$CatalogueID."'");
 return $Array;
}


function GetGroupBySubdivisionID ($SubdivisionID)
{
 global $db;

 $select = "select Groups_ID from Catalogue,Subdivision where Subdivision_ID='";
 $select .= $SubdivisionID."'";
 $select .= " and Subdivision.Catalogue_ID=Catalogue.Catalogue_ID";
@$Array = $db->get_var($select);
 return $Array;
}


function GetGroupByCatalogueID ($CatalogueID)
{
 global $db;
 $select = "select Groups_ID from Catalogue where Catalogue_ID='";
 $select .= $CatalogueID."'";
@$Array = $db->get_var($select);
 return $Array;
}


function CascadeDeleteCatalogue ($CatalogueID) {
	global $db, $MODULE_FOLDER;
  
	$SubClassResult = $db->get_results("SELECT `Sub_Class_ID`, `Class_ID` FROM `Sub_Class` WHERE `Catalogue_ID` = '".(int)$CatalogueID."'", ARRAY_N);
	$AddLockTables = "";
	if ($SubClassResult) {	
		foreach ($SubClassResult AS $SubClassArray) {
			$AddLockTables.= ", `Message".$SubClassArray[1]."` WRITE";
			$SubClassID[] = $SubClassArray[0];
			$SubClassID[] = $SubClassArray[1];
      $comments_sub_class_arr[] = $SubClassArray[0];
		}
  }

  $LockTables = "LOCK TABLES `Catalogue` WRITE, `Subdivision` WRITE, `Sub_Class` WRITE, `Log` WRITE, `Permission` WRITE";
	$LockResult = $db->query($LockTables.$AddLockTables);

	if ( nc_module_check_by_keyword("cache") ) {
    include_once ($MODULE_FOLDER."cache/function.inc.php");
    // drop cache data
    $nc_cache_listener = nc_cache_listener::getObject();
    $nc_cache_listener->event("dropCatalogue", $CatalogueID);
  }
    
  for ($i = 0; $i < count($SubClassID); $i+=2) {
		// get messages to delete
    $messagesToDelete = $db->get_col("SELECT `Message_ID` FROM `Message".$CatClassID[$i + 1]."` WHERE `Sub_Class_ID` = '".$CatClassID[$i]."'");
    // delete messages
    $db->query ("DELETE FROM `Message".$CatClassID[$i + 1]."` WHERE `Sub_Class_ID` = '".$CatClassID[$i]."'");
    if ( nc_module_check_by_keyword("cache") ) {
      // delete messages cache
      if ( !empty($messagesToDelete) ) {
        $nc_cache_listener->event("dropMessages", $CatClassID[$i+1], $messagesToDelete);
      }
    }
	}
  
	$SubResult = $db->get_results("SELECT `Subdivision_ID` FROM `Subdivision` WHERE `Catalogue_ID` = '".(int)$CatalogueID."'", ARRAY_N);
	if ( !empty($SubResult) ) {
		foreach ($SubResult AS $SubArray ) {
      DeleteFromPermission ($SubArray[0]);
      $sub_to_delete_arr[] = $SubArray[0];
    }
  }
  
  if ( nc_module_check_by_keyword("comments") ) {
    include_once ($MODULE_FOLDER."comments/function.inc.php");
    // delete comment rules
    nc_comments::dropRule( $db, array($CatalogueID) );
    // delete comments
    nc_comments::dropComments($db, $CatalogueID, "Catalogue");
  }
  
  if ( nc_module_check_by_keyword("cache") ) {
    // delete subdivisions cache
    $nc_cache_listener->event("dropSubdivision", $CatalogueID, $sub_to_delete_arr);
  }

	$db->query("DELETE FROM `Log` WHERE `Catalogue_ID` = '".(int)$CatalogueID."'");
	$db->query("DELETE FROM `Sub_Class` WHERE `Catalogue_ID` = '".(int)$CatalogueID."'");
	$db->query("DELETE FROM `Subdivision` WHERE `Catalogue_ID` = '".(int)$CatalogueID."'");
	$db->query("DELETE FROM `Catalogue` WHERE `Catalogue_ID` = '".(int)$CatalogueID."'");
	$db->query("DELETE FROM `Permission` WHERE `AdminType` = '".CATALOGUE_ADMIN."' AND `Catalogue_ID` = '".(int)$CatalogueID."'");

	$UnlockResult = $db->query("UNLOCK TABLES");

  return;
}


function HighLevelChildrenNumber ($CatalogueID, $available = '')
{
  global $db, $perm;
  
    /**
      *  sql-,    , 
      *   
      */
    $security_limit = "";

    /**
      * id ,    
      */
    $sub_admin = $perm->listItems('subdivision');
    /**
      * id   ,    
      */
    $cc_admin = $perm->listItems('subclass');
    /**
      * id ,    (  $site_admin,
      * $sub_admin, $cc_admin)
      */
    $allowed_sites = array();

    /**
      * id ,   , 
      *  $sub_admin + $cc_admin
      */
    $sub_and_cc_admin = $sub_admin;
    if ($cc_admin) {
      $res = $db->get_results("SELECT Subdivision_ID
                                 FROM Sub_Class
                                WHERE Sub_Class_ID IN (".join(',', $cc_admin).")", ARRAY_A);
      foreach ($res as $row) {
        $sub_and_cc_admin[] = $row['Subdivision_ID'];
      }
    }

    if ($sub_and_cc_admin) {
      //     ,   
      //   
      $res = $db->get_results("SELECT parent.Subdivision_ID
                                 FROM Subdivision as parent, Subdivision as allowed
                                WHERE allowed.Subdivision_ID IN (".join(',', array_unique($sub_and_cc_admin)).")
                                  AND allowed.Hidden_URL LIKE CONCAT(parent.Hidden_URL, '%')", ARRAY_A);
      /**
        * ,    
        */
      $allowed_subs = array();
      foreach ((array)$res as $row) { // flatten array
        $allowed_subs[] = $row['Subdivision_ID'];
      }

      /**
        * id ,      ,  
        *      --   
        * (as of 3.0)
        */
      $sub_child_administrator = array();
      //     
      $res = $db->get_results("SELECT child.Subdivision_ID, allowed.Subdivision_ID as Allowed_Subdivision_ID
                                 FROM Subdivision as child, Subdivision as allowed
                                WHERE allowed.Subdivision_ID IN (".join(',', array_unique($sub_admin)).")
                                  AND child.Hidden_URL LIKE CONCAT(allowed.Hidden_URL, '_%')", ARRAY_A);
      foreach ((array)$res as $row) {
        $allowed_subs[] = $row['Subdivision_ID'];
        $sub_child_administrator[ $row['Subdivision_ID'] ] = $row['Allowed_Subdivision_ID'];
      }

      if ($allowed_subs) {
        $qry_where .= " AND a.Subdivision_ID IN (".join(',', $allowed_subs).") ";
      }
    }

  $select = "select count(Subdivision_ID) from Subdivision as a where Parent_Sub_ID=0";
  $select .= " and Catalogue_ID=".$CatalogueID;

  if ($available) $select .= $qry_where;

  $Array = $db->get_var($select);
  return $Array;
}


function IsAllowedDomain ($Domain, $CatalogueID)
{
  global $db;

  $select  = "select Domain from Catalogue where Domain='".$Domain."'";
  $select .= " and Catalogue_ID<>'".$CatalogueID."'";
  $Result = $db->query ($select);
  if ($db->num_rows == 0)  return 1;

  return 0;
}

?>