/* $Id: dispatcher.js 2336 2008-10-25 15:19:07Z denis $ */

// url dispatching
urlDispatcher = {

  intervalId: 0,
  // cache compiled regexps (in sake of perfomance)
  userAreaRegExp: /(\w+(?:\.\w+)*)(?:\((.+?)\))?/,

  // initialize
  init: function() {
    window.location.oldHash = null;
    urlDispatcher.intervalId = setInterval('urlDispatcher.observe()', 150);
  },

  //   fragment- URL
  observe: function() {
    if (window.location.oldHash != window.location.hash) {
      window.location.oldHash = window.location.hash;
      this.process(window.location.hash);
    }
  },

  // change hash (call
  load: function(hash, newWindow) {
		if (!newWindow) {
			window.location.hash = hash;
		} else {
			window.open(hash, newWindow);
		}
  },

  // update without processing:
  updateHash: function(hash) {
    if (hash.substr(0, 1) != '#') hash = '#' + hash;
    window.location.hash = hash;
    window.location.oldHash = hash;
  },

  //   
  processFunction: {},

  //   url   
  route: {},

  // onHashChange
  process: function(hash) {

    hash = hash.substring(1); // remove '#'

    if (!hash) { // FIRST 'WELCOME' SCREEN
      //treeSelector.changeMode('sitemap');
      //FIRST_TREE_MODE   index.php  e,   $treeMode; a    function.inc.php
      treeSelector.changeMode(FIRST_TREE_MODE);
      
      //mainView.showStartScreen();
      //return;
      hash = '#index';
    }

    if (hash.match(this.userAreaRegExp)) {
      var functionName = RegExp.$1, param = RegExp.$2;
      //  - - - - - - - - - - -- - - -- - -- - - - - -- - - - --- --- ------
      // process url here

      //  
      if (this.processFunction[functionName]) {
        this.processFunction[functionName](param);
        return;
      }

      //   
      if (this.route[functionName]) {
        param = param.split(/\s*,\s*/);
        var url = this.route[functionName];
        for (var i=0; i < param.length; i++) {
           url = url.replace(new RegExp("[$%]"+(i+1),"g"), param[i]);
        }
        url = url.replace(/\$\d+/g, '');
        mainView.loadIframe(url);
        return;
      }
    }

    alert('Wrong params');
  }, // of urlDispatcher.process

  addRoutes: function(hashArray) {
    for (var newUrl in hashArray) {
      this.route[newUrl] = hashArray[newUrl];
    }
  }
}


bindEvent(window, 'load', function() { urlDispatcher.init();} );
