/* $Id: forms.js 2336 2008-10-25 15:19:07Z denis $
 *
 * -       .
 * - messageInitDrag
 *
 */

if (typeof formAsyncSaveEnabled == 'undefined') { formAsyncSaveEnabled = false; }
bindEvent(window, 'load', function() { bindEvent(document.body, 'keyup', formKeyHandler); });

/**
  * Form keyhandler (submits on enter, saves with XHR on Ctrl+Shift+S
  * @global {Boolean} formAsyncSaveEnabled
  */
function formKeyHandler(e) {
  if (!e && window.event) e = window.event;

  var kEnter = (e.keyCode==13),  // Enter pressed
      kSave  = (formAsyncSaveEnabled && e.shiftKey && e.ctrlKey && e.keyCode==83); // Ctrl+Shift+S

  if (!kEnter && !kSave) return;

  var srcElement = (e.srcElement? e.srcElement : e.target);

  // SUBMIT on <ENTER>
/*  if (kEnter) {
    if (srcElement.tagName == 'INPUT' && srcElement.type=='text' && !srcElement.getAttribute('nosubmit')) {
      srcElement.form.submit();
      return;
    }
    else {
      return;
    }
  }
*/
  // SAVE on <CTRL+SHIFT+S>
  if (kSave) {
    var oForm = srcElement.form ? srcElement.form : "";
    formAsyncSave(oForm); 
    parent.mainView.chan = 0;
    parent.mainView.displayStar(0);
    return;
  }

}


/**
  * Form ajax saver
  * @param,String or object
  */
function formAsyncSave(form) {

  if (!formAsyncSaveEnabled) { return; }

  // object
  if (typeof form == 'object' && form.tagName=='FORM') { oForm = form; }
  // get the form by ID
  if (typeof form == 'string') { oForm = document.getElementById(form); }
  // if it is not clear yet - save the FIRST form
  if (typeof oForm != 'object') { oForm = document.getElementsByTagName("FORM")[0]; }
  // no form!
  if (typeof oForm != 'object') { return false; }

  // collect form values into array
  var values = [];
  for (var i=0; i < oForm.length; i++) {
    var el = oForm.elements[i];
    if (el.tagName=="SELECT") {
      values[el.name] = el.options[el.options.selectedIndex].value;
    }
    else if (el.tagName=="INPUT" && (el.type=="checkbox" || el.type=="radio")) {
      if (el.checked) values[el.name] = el.value;
    }
    else if (el.name && el.value != undefined) {
      values[el.name] = el.value;
    }
  }

  values["NC_HTTP_REQUEST"] = 1; //  ,     Ajax   utf8

  statusHandlers = { '*': 'formSaveStatus(this.xhr);' };

  var xhr = new httpRequest(1); // Async request
  xhr.request('POST', oForm.action, values, statusHandlers);
  formSaveStatus(1);
}

/**
  *      XHR
  * @param {Object} XHR object
  */
function formSaveStatus(xhr) {

  var dst = document.getElementById("formAsyncSaveStatus");
  if (!dst) {
    dst = createElement("DIV", {"id": "formAsyncSaveStatus"}, document.body);
  }
  dst.style.visibility = 'visible';
  dst.style.opacity = 1;

  if (!xhr.readyState || xhr.readyState < 4) {
    dst.className = 'form_save_in_progress';
    dst.innerHTML = NETCAT_HTTP_REQUEST_SAVING;
  }
  else {
    var errorMessage = "";

    if (xhr.status=="200") { // OK
      var result = {};

      try {
        eval("var result = " + xhr.responseText);
      }
      catch (e) {
        if (xhr.responseText) errorMessage = xhr.responseText;
      }

      if (result.error) {
        alert(result.error);
        errorMessage = result.error;
      }
      else {
        dst.className = 'form_save_ok';
        dst.innerHTML = NETCAT_HTTP_REQUEST_SAVED;
        setTimeout("fadeOut('formAsyncSaveStatus')", 5000);
      }
    }
    else {
      errorMessage = xhr.status + ". " + xhr.statusText;
    }

    if (errorMessage) {
      dst.className = 'form_save_error';
      dst.innerHTML = NETCAT_HTTP_REQUEST_ERROR;
      dst.error = errorMessage;
      setTimeout("fadeOut('formAsyncSaveStatus')", 15000);
    }
  }
}

function showFormSaveError() {
  alert(document.getElementById('formAsyncSaveStatus').error);
}

function loadCustomTplSettings(catalogueId, subdivisionId, templateId) {
  var xhr = new httpRequest;
  xhr.request('GET', top.ADMIN_PATH + 'template/custom_settings.php', {catalogue_id: catalogueId, sub_id: subdivisionId, template_id: templateId });
  // synchronous HTML-HTTP-request:
  document.getElementById('customTplSettings').innerHTML = xhr.getResponseText();
  if (templateId!=0) document.getElementById('templateEditLink').onclick = function () {window.open(top.ADMIN_PATH + '#template.edit(' + templateId + ')', 1)};
}


function loadClassDescription(classId) {
  var xhr = new httpRequest;
  xhr.request('GET', top.ADMIN_PATH + 'class/get_class_description.php', {class_id: classId });
  // synchronous HTML-HTTP-request:
  document.getElementById('loadClassDescription').innerHTML = xhr.getResponseText();
}


function loadClassCustomSettings(classId) {
  var xhr = new httpRequest;
  xhr.request('GET', top.ADMIN_PATH + 'class/get_class_custom_settings.php', {class_id: classId });
  // synchronous HTML-HTTP-request:
  document.getElementById('loadClassCustomSettings').innerHTML = xhr.getResponseText();
}


function loadSubdivisionAddForm(catalogueId, subId) {
  if (subId) {
    oFormDiv = document.getElementById('sub-' + subId);
  } else {
    oFormDiv = document.getElementById('site-' + catalogueId);
  }

  if (oFormDiv.innerHTML) {
    oFormDiv.innerHTML = '';
  } else {
    var xhr = new httpRequest;
    xhr.request('GET', top.ADMIN_PATH + 'wizard/subdivision_add_form.php', {catalogue_id: catalogueId, sub_id: subId});
    // synchronous HTML-HTTP-request:
    oForm = document.createElement("form");
    oForm.id = 'ajaxSubdivisionAdd';
    oForm.name = 'ajaxSubdivisionAdd';
    oForm.innerHTML = xhr.getResponseText();
    oFormDiv.appendChild(oForm);
  }
}

//Subdivision_Name, EnglishName, TemplateID, ClassID
function saveSubdivisionAddForm() {
  oSubdivisionForm = document.getElementById('ajaxSubdivisionAdd');

  subdivisionName = oSubdivisionForm.Subdivision_Name.value;
  englishName = oSubdivisionForm.EnglishName.value;
  templateId = oSubdivisionForm.TemplateID.value;
  classId = oSubdivisionForm.ClassID.value;
  catalogueId = oSubdivisionForm.CatalogueID.value;
  subId = oSubdivisionForm.SubdivisionID.value;

  var xhr = new httpRequest;
  xhr.request('GET', top.ADMIN_PATH + 'wizard/subdivision_add.php', {subdivision_name: subdivisionName, english_name: englishName, template_id: templateId, class_id: classId, catalogue_id: catalogueId, sub_id: subId});
  // synchronous HTML-HTTP-request:

  var result = xhr.getResponseText();
  if (isNaN(result)) {
    var dst = document.getElementById("formAsyncSaveStatus");
    if (!dst) {
      dst = createElement("DIV", {"id": "formAsyncSaveStatus"}, document.body);
    }
    dst.style.visibility = 'visible';
    dst.style.opacity = 1;
    dst.className = 'form_save_error';
    dst.innerHTML = result;
    setTimeout("fadeOut('formAsyncSaveStatus')", 5000);
    return;
  }

  if (subId != 0) {
    oFormDiv = document.getElementById('sub-' + subId);
    oInsertBeforeTr = document.getElementById('tr-' + subId);
  } else {
    oFormDiv = document.getElementById('site-' + catalogueId);
    oInsertBeforeTr = document.getElementById('site_tr-' + catalogueId);
  }

  oTr1 = document.createElement('tr');
  oTr1.id = 'tr-' + result;
  oTr1.setAttribute('parentsub', subId);

  oTr2 = document.createElement('tr');

  oTd1 = document.createElement('td');
  oTd1.className = 'name active';

  oTd2 = document.createElement('td');
  oTd2.className = 'button';

  oTd3 = document.createElement('td');
  oTd3.colSpan = 2;
  oTd3.style.backgroundColor = '#FFFFFF'

  if (isNaN(parseInt(oInsertBeforeTr.firstChild.style.paddingLeft))) {
    oTd1.style.paddingLeft = 16;
    oTd3.style.padding = '0 0 0 16';
  } else {
    oTd1.style.paddingLeft = parseInt(oInsertBeforeTr.firstChild.style.paddingLeft) + 20;
    oTd3.style.paddingLeft = parseInt(oInsertBeforeTr.firstChild.style.paddingLeft) + 20;
    oTd3.style.paddingRight = 0;
    oTd3.style.paddingTop = 0;
    oTd3.style.paddingBottom = 0;
  }

  oA1 = document.createElement('a');
  oA1.href = 'index.php?phase=4&SubdivisionID=' + result;
  oA1.innerHTML = subdivisionName;

  oA2 = document.createElement('a');
  oA2.href = '#';
  oA2.onclick = function() {loadSubdivisionAddForm(catalogueId, result);}

  oImg1 = document.createElement('img');
  oImg1.src = ADMIN_PATH + 'images/arrow_sec.gif';
  oImg1.width = '14';
  oImg1.height = '10';
  oImg1.alt = '';
  oImg1.title = '';

  oImg2 = document.createElement('img');
  oImg2.src = ICON_PATH + 'i_folder_add.gif';
  oImg2.alt = ' ';
  oImg2.title = ' ';

  oSpan = document.createElement('span');
  oSpan.innerHTML = result + '. ';

  oTd1.appendChild(oImg1);
  oTd1.appendChild(oSpan);
  oTd1.appendChild(oA1);

  oA2.appendChild(oImg2);

  oTd2.appendChild(oA2);

  oTr1.appendChild(oTd1);
  oTr1.appendChild(oTd2);

  oDiv = document.createElement('div');
  oDiv.id = 'sub-' + result;

  oTr2.appendChild(oTd3);
  oTd3.appendChild(oDiv);

  bindEvent(oTr1, 'mouseover', siteMapMouseOver);
  bindEvent(oTr1, 'mouseout', siteMapMouseOut);

  bindEvent(oTr2, 'mouseover', siteMapMouseOver);
  bindEvent(oTr2, 'mouseout', siteMapMouseOut);

  oInsertBeforeTr.parentNode.insertBefore(oTr2, oInsertBeforeTr.nextSibling.nextSibling);
  oInsertBeforeTr.parentNode.insertBefore(oTr1, oInsertBeforeTr.nextSibling.nextSibling);
  oForm.parentNode.removeChild(oForm);
}


/**
  *  -  s_list_class
  */
function messageInitDrag(messageList, allowChangePriority) {
  if (!messageList) return;

  for (var classId in messageList) {
    for (var i=0; i < messageList[classId].length; i++) {
      var messageId = messageList[classId][i];
      var container = document.getElementById('message'+classId+'-'+messageId),
          handler = document.getElementById('message'+classId+'-'+messageId+'_handler');

      if (!container || !handler || !top.dragManager) continue;

      top.dragManager.addDraggable(handler, container);

      if (allowChangePriority) {
        top.dragManager.addDroppable(container, messageAcceptDrop, messageOnDrop, {name: 'arrowRight', bottom: -10, left: 0});
      }

      //  selectstart    ID   (IE)
      handler.parentNode.onselectstart = top.dragManager.cancelEvent;
    }
  }
}

/**
  *
  */
function messageAcceptDrop(e) {
  var //dragged = top.dragManager.draggedInstance,
      target  = top.dragManager.droppedInstance;

  //       (   ) -  
  //       
  if (target.type == 'message' && this.getAttribute('messageParent')==top.dragManager.draggedObject.getAttribute('messageParent')) {
    return true;
  }

  return false;
}


/**
  *
  */
function messageOnDrop(e) {
  var dragged = top.dragManager.draggedInstance,
      target  = top.dragManager.droppedInstance,
      xhr = new httpRequest();

  var res = xhr.getJson(top.ADMIN_PATH + 'subdivision/drag_manager_message.php',
              { 'dragged_type': dragged.type,
                'dragged_class': dragged.typeNum,
                'dragged_id': dragged.id,
                'target_type': target.type,
                'target_class': target.typeNum,
                'target_id': target.id
               } );

  // ( )
  if (res && target.type == 'message') {
    var oParent = top.dragManager.draggedObject.parentNode;

    oParent.removeChild(top.dragManager.draggedObject);
    //  this.nextSibling  ,  insertBefore     
    oParent.insertBefore(top.dragManager.draggedObject, this.nextSibling);
  }
}
