/* $Id: main_view.js 2506 2008-12-08 16:29:03Z denis $ */

mainView = {
  TopTitle: Array(),
  chan :0,  // 1 -  , 0 - 
  showMainView: function() {
//    this.oStartScreen.style.display = 'none';
//    this.oMainView.style.display = '';
  },

  showStartScreen: function() {
//    this.oMainView.style.display = 'none';
//    this.oStartScreen.style.display = '';
  },

  setHeader: function(headerText, imageUrl) {
    document.getElementById('mainViewHeader').innerHTML =
      "<img src='"+ICON_PATH+imageUrl+"' border='0' alt='' /><span>"+headerText+"</span>";
      this.TopTitle["headerText"] = headerText;
  },

  activeTab: null,

  addTab: function(name, caption, action, isActive, unactive) {
    var spacer = document.createElement('DIV');
    spacer.className = 'between_tabs';

    var tab = document.createElement('DIV');
    tab.id = 'mainViewTab_'+name;
    tab.className = 'tab' + (isActive ? ' sel' : '') + (unactive ? ' unactive' : '');
    if (isActive) {
      this.activeTab = tab.id;
      this.TopTitle["activeTab"] = caption;
      this.updateTopTitle();
    }

    tab.innerHTML = "<div class='tab_left'></div><div class='tab_caption'>" + 
    caption + "<span id='" + tab.id + "_span' color='#FF0000' style='display:none;'><font color='#FF0000'>*</font></span></div><div class='tab_right'></div>";
    if (!unactive) tab.onclick = new Function("mainView.switchTab('"+tab.id+"');");
    tab.action = action;

    var tabContainer = document.getElementById('mainViewTabs');
    tabContainer.appendChild(tab);
    tabContainer.appendChild(spacer);
  },

  removeAllTabs: function() {
    document.getElementById('mainViewTabs').innerHTML = '';
    this.activeTab = null;
  },

  switchTab: function(tabId, dontEvalAction) {
    if ( this.chan && REMIND_SAVE ) //Have changes and  remind save turn on
      if ( !confirm(TEXT_SAVE) ) return true;
    if (this.activeTab) {
      if (this.activeTab == tabId) { 
        if( !dontEvalAction ) { //also: call from "onlick",  but no from "update"
          this.refreshIframe();
        }
      return true;
      }
      var oActiveTab = document.getElementById(this.activeTab);
      oActiveTab.className = oActiveTab.className.replace(/\s*sel\s*/,' ');
    }
    this.displayStar(0);
    this.chan = 0;
    document.getElementById(this.activeTab).title = '';
    document.getElementById(tabId).title = TEXT_REFRESH;
    var oTab = document.getElementById(tabId);
    if (!oTab) return false;
    if (!dontEvalAction && oTab.action) { eval(oTab.action); }
    oTab.className = "tab sel";
    this.activeTab = tabId;
    this.TopTitle["activeTab"] = oTab.firstChild.textContent;
    this.updateTopTitle();
  },

  toolbar: null, // to be created during initialization on window load
  init: function() {
    this.toolbar = new toolbar('mainViewToolbar');
    this.oStartScreen = document.getElementById('startScreen');
    this.oMainView = document.getElementById('mainView');
    this.oIframe = document.getElementById('mainViewIframe');
    this.TopTitle["NetCat"] = "NetCat";
  },

  loadIframe: function(url) {
    // FF restores frame locations on reload -- prevent it
    this.showMainView();
    var fullURL = window.location.protocol + '//' + window.location.host + url;
    // location.replace doesn't makes record in window.history
    this.oIframe.contentWindow.location.replace(url);
  },

  // reloads page in the iframe
  refreshIframe: function() {
    var loc = this.oIframe.contentWindow.location.href,
        newLoc = loc.replace(/([&?]rand=)[^&]+/, "$1" + Math.random());

    if (loc == newLoc) {
      newLoc += (loc.match(/\?/) ? '&' : '?') + "rand="+Math.random();
    }

    this.oIframe.contentWindow.location.href = newLoc;
  },

  submitIframeForm: function(formId) {
    var oForm;

    if (formId) {
      oForm = document.getElementById('mainViewIframe').contentWindow.document.getElementById(formId);
    }

    if (!oForm) {
      oForm = document.getElementById('mainViewIframe').contentWindow.document.forms.item(0);
    }
    oForm.submit();
  },

  resetIframeForm: function() {
    document.getElementById('mainViewIframe').contentWindow.document.forms.item(0).reset();
  },

  /* { headerText
   *   headerImage
   *   tabs: { id
   *           caption
   *           location
   *           unactive
   *         }
   *   toolbar: [ { id
   *                caption
   *                action | location
   *                group
   *               }
   *            ]
   *   actionButtons:  [ { id
   *                       caption
   *                       action | location
   *                       align
   *                     }
   *                   ]
   *
   *   activeTab
   *   activeToolbarButtons: [ btnname1, btnname2 ]
   *
   *   locationHash
   *
   *   tabsCrc
   *   toolbarCrc
   *   actionButtonsCrc
   *
   *   treeMode
   *   treeSelectedNode
   *
   *   treeChanges { 'addNode': [ <nodeData>+ ],
   *                 'updateNode': [ <nodeData>+ ],
   *                 'deleteNode': [ nodeId+ ],
   *                 'moveNode': [ nodeId, position, refNodeId ]
   *     // both addNode and updateNode call tree.addNode()
   *
   */
  currentSettings: {headerText: null, headerImage: null, tabs: null, toolbar: null,
                    actionButtions: null, activeTab: null, locationHash: null,
                    tabsCrc: null, toolbarCrc: null, actionButtonsCrc: null},

  updateSettings: function(newSettings) {
    if (!newSettings) return false;
    var currentSettings = this.currentSettings; // 'for short'
    if (newSettings.headerText != currentSettings.headerText) {
      this.setHeader(newSettings.headerText, newSettings.headerImage);
    }

    // hash has changed
    if (newSettings.locationHash) {
      urlDispatcher.updateHash(newSettings.locationHash);
    }
    // of hash has changed

    // tabs changed
    if (newSettings.tabsCrc != currentSettings.tabsCrc) {
      this.removeAllTabs();
      for (var i=0; i < newSettings.tabs.length; i++) {
        var action = "";
        if (newSettings.tabs[i].location && !newSettings.tabs[i].unactive) {
          action = 'urlDispatcher.load("' + newSettings.tabs[i].location + '")';
        }
        var isActive = (newSettings.activeTab == newSettings.tabs[i].id);
        this.addTab(newSettings.tabs[i].id, newSettings.tabs[i].caption, action, isActive, newSettings.tabs[i].unactive);
      }
      document.getElementById('mainViewTab_' + newSettings.activeTab).title = TEXT_REFRESH;
    } //  of tabs changed
    else {
      this.switchTab('mainViewTab_'+newSettings.activeTab, true);
    }

    // toolbar has been changed
    if (newSettings.toolbarCrc != currentSettings.toolbarCrc) {
      if (!newSettings.toolbar.length) {
        this.toolbar.makeEmptyToolbar();
      }
      else if (this.toolbar) {
        this.toolbar.clear();
        for (var i=0; i<newSettings.toolbar.length; i++) {
          var btn = newSettings.toolbar[i];
          if (btn.location) btn.action = 'urlDispatcher.load("' + btn.location + '")';
          this.toolbar.addButton(btn);
        }
       } // of toolbar is not empty
     } // of toolbar has been changed

     if (newSettings.activeToolbarButtons.length && this.toolbar) {
       for (var i=0; i < newSettings.activeToolbarButtons.length; i++) {
         var oBtn = document.getElementById(this.toolbar.toolbarId + '_' + newSettings.activeToolbarButtons[i]);
         if (oBtn) {
           oBtn.turnOn();
           this.TopTitle["activeButton"] = oBtn.textContent;
           this.updateTopTitle();
         }
       }
     }

     // ActionButtons have been changed
     if (newSettings.actionButtonsCrc != currentSettings.actionButtonsCrc) {
       var html = '';
        for (var i=0; i<newSettings.actionButtons.length; i++) {
          var btn = newSettings.actionButtons[i];
          var align = (btn.align == 'left') ? 'left' : 'right';
          if (btn.location) btn.action = "urlDispatcher.load('" + btn.location + "')";
//          html += '<button style=\"float: ' + align + ';\" onclick=\"' + btn.action + '\">' + btn.caption + '</button>';
            html += '<table cellspacing="0" cellpadding="0" border="0" class=\"bottom_button\" style=\"float: ' + align + ';\" onclick=\"' + btn.action + '\"><tr>'
                    + "<td class='bottom_button_left'>&nbsp;</td>"
                    + "<td class='bottom_button_body'>"+btn.caption +"</td>"
                    + "<td class='bottom_button_right'>&nbsp;</td>"
                    + '</tr></table>';
        }
       document.getElementById('mainViewButtons').innerHTML = html;
     }

     // changes in the tree: addNode, updateNode, deleteNode
     // ANY OTHER tree METHODS CAN BE ADDED TO newSettings WITHOUT CHANGES
     // TO THIS CODE
     // drawback: must be changed in case tree methods are refactored!
     var tree;
     if (newSettings.treeChanges && (tree = document.getElementById('treeIframe').contentWindow.tree)) {
       for (var method in newSettings.treeChanges) {
         if (typeof tree[method]=='function' && newSettings.treeChanges[method].length) {
           for (var i=0; i < newSettings.treeChanges[method].length; i++) {
             // call method in the tree
             tree[method](newSettings.treeChanges[method][i]);
           }
         }
       }
     } // of if "there are tree changes and tree exists"

     // treeMode determines type of content in the tree
     if (newSettings.treeMode) {
       treeSelector.changeMode(newSettings.treeMode, newSettings.treeSelectedNode);
     }

     // SAVE SETTINGS
     this.currentSettings = newSettings;


     if (!document.all) { // reflow bugs in mozilla & opera
        triggerResize();
     }
  }, // of updateSettings()
  
  updateTopTitle: function() {
    var title=""; var i,value,value_bak;
    for (i in this.TopTitle) {
      value = this.TopTitle[i];
      if ( (value_bak && value_bak==value) || value=="" || value==undefined ) continue;
      title += ""+ (value_bak?" / ":"") + value + "";
      value_bak = value;
    }
    this.TopTitle["activeButton"] = "";
    top.window.document.title = title;
  }, // updateTopTitle
  
  displayStar: function(visible) { // . 1 - , 0 - .
    if ( document.getElementById(this.activeTab+'_span') )
      document.getElementById(this.activeTab+'_span').style.display = visible ? 'inline' : 'none';
  } //displayStar

  }; // of MAINVIEW

/** INIT **/
bindEvent(window, 'load', function() { mainView.init() });
