<?
/*
ALTER TABLE `Permission` ADD `PermissionBegin` DATETIME NULL DEFAULT NULL ,
ADD `PermissionEnd` DATETIME NULL DEFAULT NULL 
*/



class Permission {

  private $_UserID;
  private $_PermissionGroupID;
  private $_InsideAdminAccess; //     User
  
  private $db;
  private $_director, $_supervisor,  $_guest;           // 1 -    , 0 
  private $_catalogue, $_sub, $_cc;                     // ,  -  ,  - permission set
  private $_allSite;                                    //  -  permission set   
  private $_classificator;                              // ,   -   
  private $_countPerm;                            
  private $_user;                                       //  - permission set
  private $_banCat, $_banSub, $_banCC;                  // ,   $_catalogue, $_sub....
  
  private $instanceTypes = array(
    'catalogue'=>CATALOGUE_ADMIN,
    'subdivision'=>SUBDIVISION_ADMIN,
    'subclass'=>SUB_CLASS_ADMIN
  );
	
  /**
   * Constuctor
   *
   * @param int UserID
   * @param uint PermissionGroupID
   * @param int $CountPermissionGroupID //    ,    
   * @return 
   */
  function __construct ($UserID, $PermissionGroupID=0, $CountPermissionGroupID=1 ) {
    global $db;
    global $current_user;

    $this->db = $db;
    $this->_UserID = $UserID;
    
    if ( $UserID ) { //  ,        
      if ( $current_user['User_ID'] == $UserID) { //       User  
        $this->_InsideAdminAccess = $current_user['InsideAdminAccess'];    
      }
      else { //  
        $res = $db->get_row("SELECT `PermissionGroup_ID`, `InsideAdminAccess` From `User` WHERE User_ID='".$this->_UserID."'", ARRAY_A);  
        $this->_InsideAdminAccess = $res['InsideAdminAccess']; 
      }
    }
    if ($PermissionGroupID == 0) { //   ,   
      if ($CountPermissionGroupID == 1) //   
        $this->_PermissionGroupID = ( $current_user['User_ID'] == $UserID) ? $current_user['PermissionGroup_ID'] : $res['PermissionGroup_ID'];
    } 
    else {
      $this->_PermissionGroupID = $PermissionGroupID;
    }
    $this->_countPerm = 0;

    $SelectPerm = "SELECT `AdminType`, `Catalogue_ID`, `PermissionSet` 
                   FROM `Permission`
                   WHERE ( ".( ($this->_UserID > 0) ?  " `User_ID`='".$UserID."' OR " : " ")."
                          ".($this->_PermissionGroupID > 0 ? " `PermissionGroup_ID`='".$this->_PermissionGroupID."' " : " 0 " )."
                          OR 0) AND (
                          (`PermissionBegin` <= NOW() OR `PermissionBegin` IS NULL ) AND
                          (`PermissionEnd`   >= NOW() OR `PermissionEnd`   IS NULL) )";
    
    $PermResult = $this->db->get_results($SelectPerm,ARRAY_A);

    if ( !empty($PermResult) ) {
      foreach ($PermResult as  $PermArray ) { 
        switch ($PermArray['AdminType']) {
          case DIRECTOR:            
            $this->_director = 1;                                                               
            break;
          case SUPERVISOR:          
            $this->_supervisor = 1;                                                             
            break;
          case GUEST:               
            $this->_guest = 1;                                                                  
            break; 
          case CATALOGUE_ADMIN:     
            $this->_catalogue[$PermArray['Catalogue_ID']] |= $PermArray['PermissionSet'];       
            break;
          case SUBDIVISION_ADMIN:   
            $this->_sub[$PermArray['Catalogue_ID']] |= $PermArray['PermissionSet'];             
            break;
          case SUB_CLASS_ADMIN:     
            $this->_cc[$PermArray['Catalogue_ID']] |= $PermArray['PermissionSet'];              
            break;   
          case MODERATOR: //           
            $this->_user |= $PermArray['PermissionSet'];                                        
            break;
          case CLASSIFICATOR_ADMIN: 
            $this->_classificator[$PermArray['Catalogue_ID']] |= $PermArray['PermissionSet'];   
            break;    
          case BAN_SITE: //              
            $this->_banCat[$PermArray['Catalogue_ID']] |= $PermArray['PermissionSet'];          
            break;
          case BAN_SUB:             
            $this->_banSub[$PermArray['Catalogue_ID']] |= $PermArray['PermissionSet'];          
            break;
          case BAN_CC:              
            $this->_banCC[$PermArray['Catalogue_ID']]  |= $PermArray['PermissionSet'];          
            break;     
        }
        $this->_countPerm++;
      }
      
    }
   
    //  Catalogue_ID   
    if ($this->_catalogue[0] >= 0) $this->_allSite = $this->_catalogue[0]; 
    
        
  } // construct
  
  
  /**
   *  user id
   *
   * @return int usr id
   */
  function GetUserID () {
    return $this->_UserID;
  }
  


  /**
   *   ,    
   *
   * @return str login
   */
  public function getLogin () {
    global $db;
    global $AUTHORIZE_BY;
  
    $select = "SELECT `".$AUTHORIZE_BY."` From `User` WHERE User_ID='".$this->_UserID."'";
    return $this->db->get_var ($select);   
  }
    
    
  /**
   * Return, has user access to admin?
   *  ,   , , (   \ )
   *   ( )
   * @return bool
   */
  public function isInsideAdmin () { 
    //  0   InsideAdminAccess   User -      
    if ( !$this->_InsideAdminAccess ) return false;
    
    return ( $this->isInstanceModeratorAdmin('site') || 
             $this->isInstanceModeratorAdmin('sub')  || 
             $this->isInstanceModeratorAdmin('cc')   ||
             $this->isAccessDevelopment()            || 
             $this->_user                            ||
             $this->_guest );
          
  }
    

  /**
   * Is user a direcor?
   *
   * @return bool
   */
  public function isDirector () {
    return $this->_director;
  }
  
  /**
   * Is user a guest?
   *
   * @return bool
   */
  public function isGuest () {
    return $this->_guest;
  }
  
  /**
   * is user a supervisor or director
   *
   * @return bool
   */
  public function isSupervisor () {
    return ($this->_director || $this->_supervisor);
  }
  
  /**
   *   0,      
   *
   * @return 0
   */
  public function isManager () {
      return 0;
  }

   
  /* --- Catalogue --- */
  
  /**
   *        
   *
   * @param int CatalogueID, 0 - all catalogue
   * @param int mask
   * @return bool
   */
  public function isCatalogue ($CatalogueID, $mask) {
    if ($this->_director || $this->_supervisor || ($this->_allSite & $mask) ) return 1;
    return ($this->_catalogue[$CatalogueID] & $mask);
  }
  
  /**
   *      
   *
   * @return bool
   */
  public function isAllSiteAdmin () {
    if ($this->_director || $this->_supervisor ) return 1;
    return $this->_allSite & MASK_ADMIN;
  }
  
  /**
   *    - 
   *
   * @param int Catalogue ID
   * @return bool
   */
  public function isCatalogueAdmin ($CatalogueID) { 
    return $this->isCatalogue($CatalogueID, MASK_ADMIN);
  }
  
  /**
   *        ?
   *
   * @return bool
   */
  public function IsAnyCatalogueAdmin () {
    if ($this->_director || $this->_supervisor || ($this->_allSite & MASK_ADMIN) ) return 1;
    
    foreach ((array)$this->_catalogue as $v) {
      if ( $v & MASK_ADMIN ) return true;
    }
    
    return false;
  }

  
   

  
   
  /* --- Subdivision --- */
  
  /**
   *         
   *
   * @param int Subdivision ID
   * @param int mask
   * @param bool checkParents -   (..       ,   true)
   * @return bool
   */
  public function isSubdivision ($SubdivisionID, $mask, $checkParents=true) {
    
    if ($this->_director || $this->_supervisor || ($this->_allSite   & $mask) ) return true;
    if ($this->_catalogue[GetCatalogueBySubdivision($SubdivisionID)] &  $mask ) return true;
    
    if (empty($this->_sub)) return false;
    
    if ( $this->_sub[$SubdivisionID] & $mask) return true;
    
    //m    
    if ($checkParents) {
       //  id   
       $parent_sub = (array)$this->db->get_col("SELECT ths.Subdivision_ID
                                              FROM Subdivision as allowed, Subdivision as ths
                                              WHERE allowed.Subdivision_ID = '".$SubdivisionID."'   
                                              AND (allowed.Hidden_URL LIKE CONCAT(ths.Hidden_URL, '%'))
                                              AND allowed.Catalogue_ID = ths.Catalogue_ID");     
                                          
                                              
      foreach ( $parent_sub as $sub_id ) //     
        if ( $this->_sub[$sub_id] & $mask ) return true;
    }

    return false;
      
  }


/**
 *   ?
 *
 * @param int Subdivision ID
 * @param bool  ?
 * @return bool
 */
  public function isSubdivisionAdmin ($SubdivisionID, $checkParents = true) {
    return $this->isSubdivision($SubdivisionID, MASK_ADMIN, $checkParents);
  }
  
  /**
   *     ?
   *
   * @return bool
   */
  public function IsAnySubdivisionAdmin () {
    if ($this->_director || $this->_supervisor || ($this->_allSite & MASK_ADMIN) || $this->IsAnyCatalogueAdmin() ) return true;
    foreach ((array)$this->_sub as $v) {
      if ( $v & MASK_ADMIN ) return true;
    }
    return false;
  }
    
  
  
  /* --- Sub Class --- */
  
  /**
   *      
   *
   * @param int SubClassID
   * @param int  mask
   * @param bool   $parent_sub_tree;
   * @return bool
   */
  public function isSubClass ($SubClassID, $mask, $useParentSubTree = false) { 
    global $parent_sub_tree, $inside_admin; 

    if ($this->_director || $this->_supervisor || ($this->_allSite & $mask) ) return true;
    if ($this->_cc[$SubClassID] & $mask) return true;

    //       
    //       parent_sub_tree -    
    //    NC_ADDED_BY_AJAX -      , ..
    //    parent_sub_tree    
  
    if ( !$inside_admin && is_array($parent_sub_tree)  && NC_ADDED_BY_AJAX!== true && $useParentSubTree ) { 
      for ($i = 0; $i < count($parent_sub_tree) - 1; $i++) {
        $all_sub[] = $parent_sub_tree[$i]['Subdivision_ID']; 
      }
      $site = $parent_sub_tree[0]['Catalogue_ID'];

      //     -    
      if ( $this->_catalogue[$site] & $mask) return true;
      foreach ( (array)$all_sub as $v)
        if ( $this->_sub[$v] & $mask ) return true;
    
    }
    else {
      if ($this->isSubdivision(GetSubdivisionBySubClass($SubClassID), $mask ) ) return true;
    }
    
    return false;
  }
    
  /**
   *      
   *
   * @param int SubClassID
   * @return bool
   */
    public function isSubClassAdmin ($SubClassID) {
      return $this->isSubClass($SubClassID, MASK_ADMIN);
    }
    
  /**
   *     - 
   *
   * @return bool
   */
  public function isAnySubClassAdmin () {
    if ($this->_director || $this->_supervisor || ($this->_allSite & MASK_ADMIN) || $this->IsAnySubdivisionAdmin() ) return true;
    foreach ((array)$this->_cc as $v) {
      if ( $v & MASK_ADMIN ) return true;
    }
    //      - IsAnySubdivisionAdmin
    return false;
  }


  

  /**
   *           $instance_type?
   * @param string   - 'catalogue', 'subdivision', 'subclass'
   * @return boolean
   */
  function isInstanceModeratorAdmin($instance_type) {

    if ($this->_director || $this->_supervisor || $this->_allSite & (MASK_ADMIN | MASK_MODERATE) ) return true;
    
    $values = array(); //    id  (,   )
    
    switch ($instance_type ) {
      case 'catalogue' : case 'site':
        $values = array_values((array)$this->_catalogue);
        break;
      case 'subdivision' : case 'sub':
        $values = array_values((array)$this->_sub);
        break;
      case 'subclass' : case 'cc':
        $values = array_values((array)$this->_cc);
        break;
    }
    
    foreach ( $values as $v) {
      if ($v & (MASK_ADMIN | MASK_MODERATE)) return true;
    }
    
    return false;
  }





    
  /** Has user access to one (at least) classificator 
  * @return bool,  1 - has, 0 - hasn't
  */
  function isAnyClassificator () {
      if ($this->_director || $this->_supervisor) return 1;
      return (!empty($this->_classificator));
  }
  
  /** Has user acces to 'Development'?
   * @return bool,  1 - has, 0 - hasn't
   */
   function isAccessDevelopment () {
      return ( $this->_director || $this->_supervisor ||  $this->_guest || $this->isAnyClassificator() );
  }
  
  
  
  
  
  /**
   *  ? 
   *           
   * @return bool
   */
  function isAccessSiteMap () {
    if ($this->_director || $this->_supervisor || $this->_guest) return true;
    if (!empty($this->_catalogue)) return true;
    if (!empty($this->_sub)) return true;
    if (!empty($this->_cc)) return true;
    
    return false;
    
  }




    
  /**
   *      
   *    ,     
   * @param string action
   * @param int classificator id
   * @return bool
   */
  function isDirectAccessClassificator ($action = '', $id = 0) {
    $mask = 0;
    
    switch ( $action ) { //   
      case NC_PERM_ACTION_VIEW:        $mask = MASK_READ;     break;
      case NC_PERM_ACTION_ADDELEMENT:  $mask = MASK_ADD;      break;
      case NC_PERM_ACTION_EDIT:        $mask = MASK_EDIT;     break;
      case NC_PERM_ACTION_ADMIN:       $mask = MASK_MODERATE; break;

    }
   return ($this->_classificator[$id] & $mask);
       
  }
  


  function ExitIfGuest () { 
    global $NO_RIGHTS_MESSAGE;
    if ( $this->_guest ) {
      nc_print_status($NO_RIGHTS_MESSAGE, 'error');
      EndHtml ();
      exit;
    }
    return;
  }

  function ExitIfNotSupervisor () { 
    global $NO_RIGHTS_MESSAGE;
    if ( !$this->_supervisor && !$this->_director ) {
      nc_print_status($NO_RIGHTS_MESSAGE, 'error');
      EndHtml ();
      exit;
    }
    return;
  }



  /*
   *   ID ,    
   * @param string   - 'catalogue', 'subdivision', 'subclass'
   * @param string   - 'moderator', 'admin'  (  - )
   * @return array
   */
  function listItems($instance_type, $type_of_access=null) {

    $instance_num = $this->instanceTypes[strtolower($instance_type)];
    if (!$instance_num) {
      trigger_error("Unknown instance type '$instance_type'", E_USER_WARNING);
      return array();
    }
    
    $rights_mask = MASK_MODERATE | MASK_ADMIN;
    switch (strtolower($type_of_access)) {
      case 'moderator':     
        $rights_mask = MASK_MODERATE; 
        break;
      case 'admin': 
      case 'administrator': 
        $rights_mask = MASK_ADMIN; 
        break;
      case null:                               
        break;
      default:              
        $rights_mask = $type_of_access;  
        break;
    }
    
    switch ($instance_type) {
      case 'catalogue' : case 'site':
        $array = (array)$this->_catalogue; 
        break;
      case 'subdivision': case 'sub':
        $array = (array)$this->_sub; 
        break;
      case 'subclass': case 'cc':
        $array = (array)$this->_cc; 
        break;      
    } 
    
    $ret = array();
    
    foreach ($array as $k => $v) { 
      if ($v & $rights_mask) $ret[] = $k;
    }

    return $ret;
  }
    
 /**
  * ,   
  *
  * @param string  
  * @param string 
  * @param int id
  * @param string    
  * @param  int     
  * @return 1
  */
  public function ExitIfNotAccess ($instance_type, $action = "", $id = 0, $text = NETCAT_MODERATION_ERROR_NORIGHTS, $posting = 1) {
  
    if ( $this->_guest && !$posting ) return 1;
    
    if ( $this->_guest && $posting ) {
      nc_print_status(NETCAT_MODERATION_ERROR_NORIGHTGUEST, 'error');
      EndHtml ();
      exit();
    }
    
    if ( $this->_director ) return 1; 
   
    if ($this->isAccess($instance_type, $action, $id, $posting)) return 1;
    
    if ( !$text ) $text = NETCAT_MODERATION_ERROR_NORIGHTS; 
    
    //   -  
    nc_print_status($text, 'error');
    EndHtml ();
    exit();
    
    return 1;
  
  }
    
  /**
   *   
   *
   * @param int  ,  NC_PERM_*    .  const.inc.php
   * @paramint ,  NC_PERM_ACTION_*
   * @param mixed id or array with id
   * @param     
   * @return bool
   */
  public function isAccess ($instance_type, $action = '', $id = 0, $posting = 1) { 
    //   ,     
    if ( $this->_guest && !$posting ) return true;
    if ( $this->_guest &&  $posting ) return false;
 
    //       
    //    -   
    //      
    if ( $instance_type == NC_PERM_ITEM_USER || $instance_type == NC_PERM_ITEM_GROUP ) {
      if ( $this->_director ) return true;     
    }
    else {
      if ( $this->_director || $this->_supervisor) return true;     
    }
   

    switch ($instance_type ) {
      
      //Catalogue
      case NC_PERM_ITEM_SITE:
        //           
        //    viewall, add, del
        if ($this->_allSite & MASK_ADMIN ) return true;
        
        switch ($action) {
          case NC_PERM_ACTION_ADMIN:    #
          case NC_PERM_ACTION_INFO:     #    
          case NC_PERM_ACTION_EDIT:     #   
          case NC_PERM_ACTION_ADDSUB:   #     
          case NC_PERM_ACTION_DELSUB:   #   
            if ($this->_catalogue[$id] & MASK_ADMIN )  return true;
            break;
        } 

        break;
      
      // Subdivision
      case NC_PERM_ITEM_SUB:
        //    ()
        if ($this->_allSite & MASK_ADMIN) return true;
        if ($this->_catalogue[GetCatalogueBySubdivision($id)] & MASK_ADMIN) return true;
        
        switch ($action) {
          case NC_PERM_ACTION_ADD:           #  
          case NC_PERM_ACTION_DEL:           #  
          case NC_PERM_ACTION_INFO:          #    
          case NC_PERM_ACTION_EDIT:          #   ()
          case NC_PERM_ACTION_SUBCLASSLIST:  #   
          case NC_PERM_ACTION_SUBCLASSDEL:   #    
          case NC_PERM_ACTION_SUBCLASSADD:   # 
            if ( $this->isSubdivision($id, MASK_ADMIN) ) return true;;
            break;
          case NC_PERM_ACTION_LIST:           #          
            if ( $this->isSubdivision($id, MASK_ADMIN | MASK_MODERATE) ) return true;
            break;
        }

        break;
       
        
      // Sub class   
      case NC_PERM_ITEM_CC:       
        // ,       
        if ($this->_allSite & MASK_ADMIN) return true;
        if ($this->_catalogue[GetCatalogueBySubdivision($id[0])] & MASK_ADMIN) return true;
        if ($this->isSubdivision($id[0], MASK_ADMIN))  return true;
        
        $id = (array)$id; //  - id ,  - sub clas id
        
        switch ( $action) {
          case NC_PERM_ACTION_ADMIN:      #
          case NC_PERM_ACTION_EDIT:       #   
            if ( $this->_cc[$id[1]]  & MASK_ADMIN )  return true;  
            break;
          case NC_PERM_ACTION_INFO:       #   
            if ( $this->_cc[$id[0]]  & MASK_ADMIN )  return true;  
            break;
            
        }

        break;
       
      // User 
      case NC_PERM_ITEM_USER:
        //  ,       
        $not_allow_users = $this->GetUserWithMoreRights();
        // ,     
        $not_allow_user =  in_array($id, (array)$not_allow_users);

        switch ( $action) {
          case NC_PERM_ACTION_ADD:   #   
            if ( $this->_user & MASK_ADD || $this->_supervisor ) return true;
            break;
          case NC_PERM_ACTION_LIST:  #   
            if ( $this->_user & MASK_READ || $this->_supervisor ) return true;
            break; 
          case NC_PERM_ACTION_EDIT:  #  
            if ( $not_allow_user )          return false;
            if ( $this->_user & MASK_EDIT || $this->_supervisor  ) return true;
            break;
          case NC_PERM_ACTION_RIGHT:  #  
            if ( $not_allow_user )          return false;
            if ( $this->_user & MASK_EDIT || $this->_supervisor  ) return true;
            break;
          case NC_PERM_ACTION_RIGHT: #    -   ""
            if ( $not_allow_user )          return false;
            if ( $this->_user & MASK_EDIT || $this->_supervisor ) return true;
            break;
          case NC_PERM_ACTION_DEL:  #  
            if ( $not_allow_user )          return false;
            if ( $this->_user & MASK_MODERATE || $this->_supervisor ) return true;
            break;
            
            
        }

        break;
      
        //group
      case NC_PERM_ITEM_GROUP: 
        //     
        if (!$this->_supervisor) return false;
        //   
        if ($action == NC_PERM_ACTION_LIST ) return true;
        //    "" 
        if ( !in_array($id, $this->GetDirectorsGroup() ) ) return true; 
        break;

        // classificator    
      case NC_PERM_CLASSIFICATOR:
        switch ( $action ) {
          case NC_PERM_ACTION_LIST: #  
            if ( !empty($this->_classificator) ) return true; 
            break;
          case NC_PERM_ACTION_ADD:  # \\     
          case NC_PERM_ACTION_DEL:
            //     
            if ( $this->_classificator[0] & MASK_MODERATE ) return true;
            break;
          case NC_PERM_ACTION_VIEW: #  
            if ( $this->_classificator[$id] & MASK_READ ) return true;
            if ( $this->_classificator[0]   & MASK_READ ) return true;
            break;
          case NC_PERM_ACTION_ADMIN:  #  ,   
            if ( $this->_classificator[$id] & MASK_MODERATE ) return true;
            if ( $this->_classificator[0]   & MASK_MODERATE ) return true;
            break;
          case NC_PERM_ACTION_ADDELEMENT: #   
            if ( $this->_classificator[$id] & MASK_ADD ) return true;
            if ( $this->_classificator[0]   & MASK_ADD ) return true;
            break;
          case NC_PERM_ACTION_EDIT: #     
            if ( $this->_classificator[$id] & MASK_EDIT ) return true;
            if ( $this->_classificator[0]   & MASK_EDIT ) return true;
            break;
            
        }
        
      case NC_PERM_FAVORITE:
        return $this->IsAnySubdivisionAdmin();
        break;
       
        
      //only supervisor and director
      case NC_PERM_SQL:     
      case NC_PERM_FAVORITE:
      case NC_PERM_CLASS:
      case NC_PERM_FIELD:
      case NC_PERM_SYSTABLE:
      case NC_PERM_MODULE:
      case NC_PERM_PATCH:
      case NC_PERM_REPORT:
      case NC_PERM_TEMPLATE:
        break; 
          
        }
        
    
    return false;

  }

  /**
   * ,         cc
   *
   * @param array cc_env,   Sub_Class_ID, Subdivision_ID, Catalogue_ID 
   * @param unknown_type $action
   * @return unknown
   */
  public function isBanned ($cc_env, $action) { 
    global $parent_sub_tree; 
    
    if ( !$this->_banCC && !$this->_banSub && !$this->_banCat ) return false;
      
    // action  
    switch ($action) {
      case 'read':        $mask = MASK_READ;       break;
      case 'add':         $mask = MASK_ADD;        break;
      case 'change':      $mask = MASK_EDIT;       break;
      case 'moderate':    $mask = MASK_MODERATE;   break;
      case 'subscribe':   $mask = MASK_SUBSCRIBE;  break;
      case 'comment':     $mask = MASK_COMMENT;    break;
      default:            $mask = MASK_READ;       break;
    }

    //   ""
    if ($this->_banCC[$cc_env['Sub_Class_ID']]    & $mask ) return true;
    if ($this->_banSub[$cc_env['Subdivision_ID']] & $mask ) return true;
    if ($this->_banCat[$cc_env['Catalogue_ID']]   & $mask ) return true;
    
    //        
    //    parent_sub_tree -   
    //  -  
    //    
    if ( is_array($parent_sub_tree) ) {
      // 0    -      
      for ( $i = 1; $i < count($parent_sub_tree) - 1; $i++)
        $parent_sub[] = $parent_sub_tree[$i]['Subdivision_ID'];
    }
    else {
      $parent_sub = $this->db->get_col("SELECT parent.`Subdivision_ID`
                                        FROM `Subdivision` as parent, `Subdivision` as child
                                        WHERE child.`Subdivision_ID` = '".$cc_env['Subdivision_ID']."'
                                        AND child.`Hidden_URL` LIKE CONCAT(parent.`Hidden_URL`, '%')
                                        AND parent.`Catalogue_ID` = child.`Catalogue_ID` ");
    } 
    
    foreach ( (array)$parent_sub as $v ) {
      if ($this->_banSub[$v] & $mask) return true;  
    }
     
    //,           
    if ($this->_banCat[$cc_env['Catalogue_ID']] & $mask ) return true;  //   
    if ($this->_banCat[0]                       & $mask ) return true;  //      
  

    return false;
  }
  
  /**
   * Return perm name
   *     
   * @return unknown
   */
  public function GetMaxPerm () {
    if ($this->_director)              return BEGINHTML_PERM_DIRECTOR;
    if ($this->_supervisor)            return BEGINHTML_PERM_SUPERVISOR;
    if (!empty($this->_catalogue))     return BEGINHTML_PERM_CATALOGUEADMIN;
    if (!empty($this->_sub))           return BEGINHTML_PERM_SUBDIVISIONADMIN;
    if (!empty($this->_cc))            return BEGINHTML_PERM_SUBCLASSADMIN;
    if ($this->_user)                  return BEGINHTML_PERM_MODERATOR;
    if (!empty($this->_classificator)) return BEGINHTML_PERM_CLASSIFICATORADMIN;
    if ($this->_guest)                 return BEGINHTML_PERM_GUEST;
    
    return 0;
  }
  
  /**
   *  cataqlogue id,        
   *   ,  
   *
   * @param int mask 
   * @param bool  sub class
   * @return mixed 1.array([0]=>id, [1] => id...) 2. null -     
   */
  public function GetAllowSite ($mask = MASK_ADMIN,  $withSubClass = true) {

    if ( $this->_director || $this->_supervisor || $this->_guest || ($this->_allSite & $mask) ) return;
  
    $site_list = (array)$this->listItems('catalogue', $mask);
    
    $temp = $this->listItems('subdivision', $mask);
    if ($temp )  $site_list = array_merge($this->db->get_col("SELECT `Catalogue_ID` FROM `Subdivision`
                               WHERE `Subdivision_ID` IN (".join(', ', $temp).")"), $site_list);
    
    if ($withSubClass) {
      $temp = $this->listItems('subclass', $mask);
      if ($temp )  $site_list = array_merge($this->db->get_col("SELECT `Catalogue_ID` FROM `Sub_Class`
                               WHERE `Sub_Class_ID` IN (".join(', ', $temp).")"), $site_list);
    }
    
    $site_list = array_unique((array)$site_list);
    
    if (empty($site_list)) return array(-1); //     
    
    return $site_list; 
    
  }
  
  
  /**
   *   ,      (+  ,  )
   * 
   * @param int CatalogueID
   * @param int $mask
   * @param bool withParent -    -  ,       ,  
   *     ,     
   * @param bool WithChild -   ,      
   * @param bool withSubClass -  ,      
   * @return mixed array ([0] => id, [1] => id)  null -   
   */
  public function GetAllowSub ( $CatalogueID, $mask = MASK_ADMIN, $withParent = true, $withChild = true, $withSubClass = true ) {
    
    if ($this->_director ||  $this->_supervisor || ($this->_catalogue[$CatalogueID] & $mask) || ($this->_allSite & $mask) ) return ;
    
    $allow = array(); // 
    $temp = array();
    
    //    
    foreach ((array)$this->_sub as $k => $v) {    
      if ($v & $mask) {
        $allow[] = $k;    
      }
    }
      
    if ( $withChild ) { 
      //    
      $allow = array_merge( (array)$allow, (array)$this->_GetChildrenSub($allow) );   
    }
    
    if ($withSubClass) { 
      foreach ( (array)$this->_cc as $k => $v ) {
        if ($v & $mask) $temp[] = $k;
      }
      if ( !empty($temp) ) $temp = $this->db->get_col("SELECT `Subdivision_ID` FROM `Sub_Class` WHERE `Sub_Class_ID` IN(".join(',',$temp).")");
    
      $allow = array_merge( (array)$allow, (array)$temp);
    }
     
    if (empty($allow)) return array(-1);
    
    $allow = array_unique($allow);
    
    if ($withParent) {
       $temp = $this->db->get_col("SELECT parent.`Subdivision_ID`
                                       FROM `Subdivision` as parent, `Subdivision` as allowed
                                      WHERE allowed.`Subdivision_ID` IN (".join(',', $allow).")
                                        AND allowed.`Hidden_URL` LIKE CONCAT(parent.`Hidden_URL`, '%')");
       $allow = array_merge( $allow, (array)$temp); 
    }
    
    if (empty($allow)) return array(-1);
    
    $allow = array_unique($allow);
    
    return $allow; 
  
  }
  
  
  /* --- Methods for work with users --- */
  
  
  /**
   *    ""    
   *  -    ,    
   * @return unknown
   */
  public function isUserMenuShow () {
    return (!$this->_supervisor && !$this->_director &&  !$this->_guest && $this->_user);
  }
  
  /**
   * Return all users id, which have right > this
   * So, if this - supervisor  return direcors id; this = moderator: return supervisors and directors id..
   *
   * @return array array with users id
   */
  public function GetUserWithMoreRights () {
    static $init_static, $ret_static;
    
    if ( $init_static ) return (array)$ret_static;
    
    $ret = array();
    if ( $this->_director) return $ret;
    
    //    ,      
    $where = "`AdminType` = '".DIRECTOR."'";    
    //     ,        ,    - 
    //    ,   
    if (!$this->_supervisor) $where .= " OR AdminType NOT IN (".BAN_SITE.", ".BAN_SUB.", ".BAN_CC.")";
    //if (!$this->_supervisor) $where .= " OR `AdminType` = '".SUPERVISOR."'";
    
    $ret = $this->db->get_col("SELECT `User_ID` FROM `Permission` WHERE ".$where);
    
    //    ,   ,    ,    
    $ret = array_merge((array)$ret, (array)$this->db->get_col("SELECT us.`User_ID` FROM `User` as us, `Permission` as per
                                                               WHERE us.`PermissionGroup_ID` = per.`PermissionGroup_ID`
                                                               AND (".$where." )")); 
    $init_static = true;
    $ret_static = $ret;
    
    return (array)$ret;
   
  }
  
  /**
   *    ,  -
   *
   * @todo ,    ,   ,    -
   * @return array
   */
  public function GetDirectorsGroup () {
    $ret = $this->db->get_col("SELECT `PermissionGroup_ID` FROM `Permission` WHERE AdminType = '".DIRECTOR."' AND `PermissionGroup_ID` <> 0");
    return (array)$ret;    
  }
  
  /**
   *       
   *  "" -  ,    "":
   * ID, live ( ), AdminType, title,  0, 1,2,3 4,5, ...
   * 0 1 2 3 4 5 -  , , , , -  - (  ,     )
   *   -  , : 'checkbox' - 0 - , 1 - , 2 -  , 3 -    
   *                                    'mask' -      -    (1, 2,4,8,16....)
   *     ,  "-1" -      (, ...)
   *
   * @param int UserID
   * @param int GroupID
   * @return array
   */
  public static function GetAllPermission ($UserID, $GroupID = 0) {
    global $db;
    //  
    if ($GroupID) {
      $Result = $db->get_results("SELECT * FROM `Permission` WHERE `PermissionGroup_ID`='".(int)$GroupID."'", ARRAY_A);
    }
    else {
      $Result = $db->get_results("SELECT * FROM `Permission` WHERE `User_ID`='".(int)$UserID."'", ARRAY_A);
    } 
   
    foreach ((array)$Result as $prm) {
      $id = $prm['Permission_ID'];
      
      switch (true) { //  live -  
        case (!$prm['PermissionBegin'] && !$prm['PermissionEnd']): 
          $ret[$id]['live'] = CONTROL_USER_RIGHTS_UNLIMITED; 
          break;
        case ( $prm['PermissionBegin'] &&  $prm['PermissionEnd']): 
          $ret[$id]['live'] = "c ".$prm['PermissionBegin']. "  ".$prm['PermissionEnd']; 
          break;
        case ( $prm['PermissionBegin'] && !$prm['PermissionEnd']): 
          $ret[$id]['live'] = "c ".$prm['PermissionBegin']; 
          break;
        case (!$prm['PermissionBegin'] &&  $prm['PermissionEnd']): 
          $ret[$id]['live'] =  " ".$prm['PermissionEnd']; 
          break;
      }
      
      $ret[$id]['AdminType'] = $prm['AdminType'];
      $ret[$id]['ID']  = $prm['AdminType'];
      $ps = $prm['PermissionSet']; // ps - permission set
      $c_id = $prm['Catalogue_ID'];
      
      // r - read, e - edit, d - add, s - subsribe, m - moderate, a - admin
      //    , - checkbox'
      $r = ($ps & MASK_READ) ? 1 : 0;      $d = ($ps & MASK_ADD) ? 1 : 0;      $e = ($ps & MASK_EDIT) ? 1 : 0;
      $s = ($ps & MASK_SUBSCRIBE) ? 1 : 0; $m = ($ps & MASK_MODERATE) ? 1 : 0; $a = ($ps & MASK_ADMIN) ? 1 : 0;
      $c = ($ps & MASK_COMMENT) ? 1 : 0;
      
      $ret[$id]['title'] = Permission::GetPermNameByID($prm['AdminType']);
      $ret[$id]['title'] .= " ";   
      
      switch ($prm['AdminType']) {
        case DIRECTOR: case SUPERVISOR: case GUEST:
          //   -....-- 
          $r = $c = $e = $d = $s = $m = $a = -1;
          break;
        case BAN_SITE: 
          $m = $a = 3; //    
          
          if ($c_id) { // 
            $ret[$id]['title'] .= "\"".GetCatalogueNameByID($c_id)."\"";   
          }
          else {  //  
            $ret[$id]['title'] = CONTROL_USER_RIGHTS_SITEALL;                    
          }
          break;
        case CATALOGUE_ADMIN: 
          if ($c_id) {
            $ret[$id]['title'] .= "\"".GetCatalogueNameByID($c_id)."\"";
          }
          else { 
            $ret[$id]['title'] = CONTROL_USER_RIGHTS_CATALOGUEADMINALL;
          }
          break;
        case BAN_SUB:
          $m = $a = 3; //    
          // zdec break ne nugen
        case SUBDIVISION_ADMIN: 
          $ret[$id]['title'] .= " \"".GetSubdivisionNameByID($c_id)."\" ".CONTROL_USER_FUNCS_FROMCAT."  \"".GetCatalogueNameBySubdivisionID($c_id)."\"";
          break;
        case BAN_CC:
          $m = $a = 3; // zdec break ne nugen   
        case SUB_CLASS_ADMIN: 
          $ret[$id]['title'] .= " \"".GetSubClassName($c_id)."\" ".CONTROL_USER_FUNCS_FROMSEC."  \"".GetSubdivisionNameByID(GetSubdivisionBySubClass($c_id))."\"";
          break;
        case CLASSIFICATOR_ADMIN:
          $r = 2; $s = 3;  $a = 3; $c = 3; //  - ,   - 
          if ($c_id) {
            $ret[$id]['title'] .= "\"".Permission::_GetClassificatorNameByID($c_id)."\"";
          }
          else {
            $ret[$id]['title'] = CONTROL_USER_RIGHTS_CLASSIFICATORADMINALL;
          }
          break;
        case MODERATOR:
          $r = 2; $s = $a = 3; $c = 3;  //  - ,   - 
          break;
          
      }
      $ret[$id][NC_PERM_READ_ID]['checkbox']      = $r;  $ret[$id][NC_PERM_READ_ID]['mask']      = MASK_READ;
      $ret[$id][NC_PERM_ADD_ID]['checkbox']       = $d;  $ret[$id][NC_PERM_ADD_ID]['mask']       = MASK_ADD; 
      $ret[$id][NC_PERM_EDIT_ID]['checkbox']      = $e;  $ret[$id][NC_PERM_EDIT_ID]['mask']      = MASK_EDIT;
      $ret[$id][NC_PERM_SUBCRIBE_ID]['checkbox']  = $s;  $ret[$id][NC_PERM_SUBCRIBE_ID]['mask']  = MASK_SUBSCRIBE;
      $ret[$id][NC_PERM_MODERATE_ID]['checkbox']  = $m;  $ret[$id][NC_PERM_MODERATE_ID]['mask']  = MASK_MODERATE; 
      $ret[$id][NC_PERM_ADMIN_ID]['checkbox']     = $a;  $ret[$id][NC_PERM_ADMIN_ID]['mask']     = MASK_ADMIN;
      $ret[$id][NC_PERM_COMMENT_ID]['checkbox']   = $c;  $ret[$id][NC_PERM_COMMENT_ID]['mask']   = MASK_COMMENT;
    }
   
    //      - cmp
    if (!empty($ret))
      uasort($ret, 'Permission::_cmp'); 
    return $ret;
  }
  
  
  /**
   *  ""    id
   *
   * @param int id
   * @return str
   */
  private static function GetPermNameByID ($id) {
    switch ($id) {
      case 7:  return CONTROL_USER_RIGHTS_DIRECTOR;
      case 6:  return CONTROL_USER_RIGHTS_SUPERVISOR;
      case 4:  return CONTROL_USER_RIGHTS_SITEADMIN;
      case 3:  return CONTROL_USER_RIGHTS_SUBDIVISIONADMIN;
      case 9:  return CONTROL_USER_RIGHTS_SUBCLASSADMIN;
      case 15: return CONTROL_USER_RIGHTS_CLASSIFICATORADMIN;
      case 8:  return CONTROL_USER_RIGHTS_GUESTONE;
      case 12: return CONTROL_USER_RIGHTS_MODERATOR;
      case 21: return CONTROL_USER_RIGHTS_SITE;
      case 22: return CONTROL_USER_RIGHTS_SUB;
      case 23: return CONTROL_USER_RIGHTS_CC;
    }
    return;
  }
  
  
  
  /**
   *    
   *
   * @param unknown_type $sub
   * @todo    ,   , .. ,       ,
   *      
   * @return unknown
   */
  private function _GetChildrenSub ( $sub ) {
    global $db;
    
    $sub = (array)$sub;
    if ( empty($sub) ) return;
    /*
    $ret = $db->get_col("SELECT `Subdivision_ID` FROM `Subdivision` WHERE `Parent_Sub_ID` IN (".join(", ", $sub).")");
  
    if ( empty($ret) ) return;
  
    $ret = array_merge( $ret, (array)GetChildrenSub($ret) );  
    */
   $ret = (array)$db->get_col("SELECT child.`Subdivision_ID`
                               FROM `Subdivision` as child, `Subdivision` as parent
                               WHERE parent.`Subdivision_ID` IN (".join(',', array_unique($sub)).")
                               AND child.`Hidden_URL` LIKE CONCAT(parent.`Hidden_URL`, '%')
                               AND child.`Subdivision_ID` <> parent.`Subdivision_ID`
                               ");
  return $ret;
}
  /**
   *     id
   *
   * @return unknown
   */
  private function _GetClassificatorNameByID ($ClassificatorID) {
    global $db;
    $Array = $db->get_var("select Classificator_Name from Classificator where Classificator_ID='".$ClassificatorID."'");
    return $Array;
  }

  /**
   * ,   
   *     
   *
   * @param  array $a,    AdminType -      
   * @param  array $b
   * @return 0, 1, - 1 -   ,     
   */
  private static function _cmp ( $a, $b) { 
    //      , ..
    //    ,  ....
    static $order_array = array(DIRECTOR, SUPERVISOR, GUEST, 
                         MODERATOR, CLASSIFICATOR_ADMIN, 
                         CATALOGUE_ADMIN, SUBDIVISION_ADMIN, SUB_CLASS_ADMIN,
                         BAN_SITE, BAN_SUB, BAN_CC);
                         
    if ( $a['AdminType'] == $b['AdminType'] ) return 0;
    
    // ,    AdminType   e   order_array
    foreach ( $order_array as $k => $v ) { 
      if ( $v == $a['AdminType'] ) $a_id = $k;
      if ( $v == $b['AdminType'] ) $b_id = $k;
    }
   
    return ($a_id < $b_id) ? -1 : 1;
  }


}

?>
