<?php

/* $Id: drag_manager_sitemap.php 2377 2008-11-12 18:02:53Z vadim $ */
/**
  *  D&D:
  *  - subdivision to subdivision
  *  - subdivision to site
  *  - site to site
  */

ob_start("ob_gzhandler");

define("NC_ADMIN_ASK_PASSWORD", false);

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");
require_once ($ADMIN_FOLDER."subdivision/function.inc.php");

if ( nc_module_check_by_keyword("cache") ) {
  include_once ($MODULE_FOLDER."cache/function.inc.php");
  // init listener
  $nc_cache_listener = nc_cache_listener::getObject();
}

$dragged_id = (int)$dragged_id;
$target_id =  (int)$target_id;
if (!$dragged_id || !$target_id)  die("0 /* Wrong parameters */");


// INPUT: $dragged_type, $dragged_id, $target_type, $target_id, $position [inside|below]
// dropped subdivision on another subdivision or to the site
if ( $dragged_type=='sub' && ($target_type=='sub' || $target_type=='site') ) {

  // dragged sub info
  $dragged = $db->get_row("SELECT * FROM `Subdivision` WHERE `Subdivision_ID` = '".$dragged_id."'", ARRAY_A);

  // target (sub or site) info
  if ($target_type=='sub') {
    $target = $db->get_row("SELECT * FROM `Subdivision` WHERE `Subdivision_ID` = '".$target_id."'",  ARRAY_A);
  }
  elseif ($target_type=='site') {
    $target = array(
      'Catalogue_ID' => $target_id,
      'Hidden_URL' => '/',
      'Parent_Sub_ID' => 0,
      'Subdivision_ID' => 0
    );
  }

  if (!$dragged || !$target) die("0 /* Wrong IDs */");

  
  // check rights for dragged object
  if ( !$perm->isSubdivisionAdmin($dragged['Subdivision_ID']) ) {
    die("0 /* No sufficient rights for dragged ".$dragged_type." ".$dragged_id." */");
  }
  // check rights for target object
  if ( $target_type=='sub' && !$perm->isSubdivisionAdmin($target['Subdivision_ID']) ) {
    die("0 /* No sufficient rights for target ".$target_type." ".$target_id." */");
  }
  elseif ( $target_type=='site' && !$perm->isCatalogueAdmin($target_id) ) {
    die("0 /* No sufficient rights for ".$target_type." ".$target_id." */");
  }


  if ($position=='inside') {
    $priority = 0;
    $parent_sub = $target['Subdivision_ID'];
  }
  elseif ($position=='below') {
    $priority = $target['Priority'];
    if ($target['Parent_Sub_ID'] != $dragged['Parent_Sub_ID']) { $priority++; }
    $parent_sub = $target['Parent_Sub_ID'];
  }
  else {
    die("0 /* Wrong parameter \$position = ".$position." */");
  }

  // if drag sub in current parent sub
  if ($dragged['Parent_Sub_ID'] == $parent_sub) {
    // changing priority, but not the parent
    if ($target['Priority'] > $dragged['Priority']) {
      // moving item downwards
      $db->query("UPDATE `Subdivision`
        SET `Priority` = `Priority` - 1
        WHERE `Parent_Sub_ID` = '".$parent_sub."'
        AND `Priority` BETWEEN '".$dragged['Priority']."' AND '".$priority."'
        AND `Subdivision_ID` != '".$dragged['Subdivision_ID']."'");
    }
    else {
      // moving item upwards
      if ($priority != 0 || $position=='below') $priority = $target['Priority'] + 1;
      $db->query("UPDATE `Subdivision`
        SET `Priority` = `Priority` + 1
        WHERE `Parent_Sub_ID` = '".$parent_sub."'
        AND `Priority` BETWEEN '".$priority."' AND '".$dragged['Priority']."'
        AND `Subdivision_ID` != '".$dragged['Subdivision_ID']."'");
    }
    if ( nc_module_check_by_keyword("cache") ) {
      $children_sub_id = (array)GetChildrenSub( array($parent_sub, $dragged['Subdivision_ID']) );
      $tmp_arr = array_merge( $children_sub_id, array($parent_sub, $dragged['Subdivision_ID']) );
      // delete cache
      $nc_cache_listener->event("dropSubdivision", $dragged['Catalogue_ID'], $tmp_arr );
    }
  }
  else {
    // parent has changed
    // make room for inserted/moved node at the new parent
    $db->query("UPDATE `Subdivision` SET `Priority` = `Priority` + 1
      WHERE `Parent_Sub_ID` = '".$parent_sub."' AND `Priority` >= '".$priority."'");

    // collapse gap at the old parent subdivision
    $db->query("UPDATE `Subdivision`
      SET `Priority` = `Priority` - 1
      WHERE `Parent_Sub_ID` = '".$dragged['Parent_Sub_ID']."'
      AND `Priority` > '".$dragged['Priority']."'
      AND `Subdivision_ID` != '".$dragged['Subdivision_ID']."'");

    if ( nc_module_check_by_keyword("cache") ) {
      // delete cache
      if ($dragged['Catalogue_ID']==$target['Catalogue_ID']) {
        $children_sub_id = (array)GetChildrenSub( array($parent_sub, $dragged['Parent_Sub_ID'], $dragged['Subdivision_ID']) );
        $tmp_arr = array_merge( $children_sub_id, array($parent_sub, $dragged['Parent_Sub_ID'], $dragged['Subdivision_ID']) );
        $nc_cache_listener->event("dropSubdivision", $dragged['Catalogue_ID'], $tmp_arr );
      }
      else {
        $children_sub_id = (array)GetChildrenSub( array($dragged['Parent_Sub_ID'], $dragged['Subdivision_ID']) );
        $tmp_arr = array_merge( $children_sub_id, array($dragged['Parent_Sub_ID'], $dragged['Subdivision_ID']) );
        $nc_cache_listener->event("dropSubdivision", $dragged['Catalogue_ID'], $tmp_arr );
        $tmp_arr = (array)GetChildrenSub($parent_sub);
        $tmp_arr[] = $parent_sub;
        $nc_cache_listener->event("dropSubdivision", $target['Catalogue_ID'], $tmp_arr);        
      }
    }
    
      
    // update hidden url
    // REPLACE() was not used because there's no way to match from the first symbol
    $old_length = strlen(preg_replace("#[^/]+/$#", "", $dragged['Hidden_URL'])) + 1;
    $new_parent_url = $target["Hidden_URL"];
    if ($position == 'below') { // target's parent
      $new_parent_url = preg_replace("#[^/]+/$#", "", $new_parent_url);
    }

    $db->query("UPDATE `Subdivision`
      SET `Hidden_URL` = CONCAT( '".$new_parent_url."', SUBSTRING(`Hidden_URL` FROM ".$old_length.") )
      WHERE `Hidden_URL` LIKE '".$dragged['Hidden_URL']."%'");
  }

  // move subdivision
  $db->query("UPDATE `Subdivision`
    SET `Parent_Sub_ID` = '".$parent_sub."', `Catalogue_ID` = '".$target['Catalogue_ID']."', `Priority` = '".$priority."'
    WHERE `Subdivision_ID` = '".$dragged['Subdivision_ID']."'");

  // get children data
  $chil_sub_id = GetChildrenSub($dragged['Subdivision_ID']);

  if (count($chil_sub_id)) {
    foreach ( $chil_sub_id as $v ) {
      $db->query("UPDATE `Subdivision` SET `Catalogue_ID` = '".$target['Catalogue_ID']."' WHERE `Subdivision_ID` = '".$v."'");
      $db->query("UPDATE `Sub_Class` SET `Catalogue_ID` = '".$target['Catalogue_ID']."' WHERE `Subdivision_ID` = '".$v."'");
    }
  }
  
  $db->query("UPDATE `Sub_Class`
    SET `Catalogue_ID` = '".$target['Catalogue_ID']."'
    WHERE `Subdivision_ID` = '".$dragged['Subdivision_ID']."'");

  if ($target_type=='site' && ($target['Catalogue_ID'] != $dragged['Catalogue_ID'])) {
  	$parent_subs_array = nc_get_subdivision_children($dragged['Subdivision_ID']);
  	
  	if ( !empty($parent_subs_array) ) {
  	  $db->query("UPDATE `Subdivision` SET `Catalogue_ID` = '".$target['Catalogue_ID']."' WHERE `Subdivision_ID` IN (".join(', ', $parent_subs_array).")");
  	  $db->query("UPDATE `Sub_Class` SET `Catalogue_ID` = '".$target['Catalogue_ID']."' WHERE `Subdivision_ID` IN (".join(', ', $parent_subs_array).")");
    }
  }

  die("1 /* OK */");
}

if ($dragged_type=='site' && $target_type=='site') {
  // dragged site info
  $dragged = $db->get_var("SELECT `Priority` FROM `Catalogue` WHERE `Catalogue_ID` = '".$dragged_id."'");
  // target site info
  $target = $db->get_var("SELECT `Priority` FROM `Catalogue` WHERE `Catalogue_ID` = '".$target_id."'");
  
  if ( $perm->isCatalogueAdmin($dragged_id) && $perm->isCatalogueAdmin($target_id)  ) {
   
    if ($dragged_id <= $target_id) {
      $db->query("UPDATE `Catalogue` SET `Priority` = `Priority` - 1
        WHERE `Priority` > '".$dragged."' AND `Priority` <= '".$target."' OR `Catalogue_ID` = '".$target_id."'");
      $db->query("UPDATE `Catalogue` SET `Priority` = '".$target."'
        WHERE `Catalogue_ID` = '".$dragged_id."'");
    }
    else {
      $db->query("UPDATE `Catalogue` SET `Priority` = `Priority` + 1
        WHERE `Priority` > '".$target."' AND `Priority` < '".$dragged."'");
      $db->query("UPDATE `Catalogue` SET `Priority` = '".$target."' + 1
        WHERE `Catalogue_ID` = '".$dragged_id."'");
    }
    
  }

  die("1 /* OK */");
}

// dropped subclass on subdivision
if ($dragged_type=='subclass' && $target_type=='sub') {
  $ret = nc_move_subclass($dragged_id, $target_id);
  die( (int)$ret."/**/" );
}

die("0 /* Wrong request ['".$dragged_type." ".$dragged_id."' ".$position." '".$target_type." ".$target_id."'] */");

?>