<?php
/* $Id: e404.php 2464 2008-12-05 13:58:13Z vadim $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ROOT_FOLDER."connect_io.php");

/*
///////////////////////
require("Benchmark/Timer.php");
$nccttimer = new Benchmark_Timer();
$nccttimer->start();
///////////////////////
$db->debug_all = true;
$db->benchmark = true;
///////////////////////////////////
*/
require($INCLUDE_FOLDER."s_e404.inc.php");
require($INCLUDE_FOLDER."s_loadenv.inc.php");

if (substr($REQUEST_URI, 0, 1) != "/") $REQUEST_URI="/".$REQUEST_URI;

$HTTP_FILES_PATH_PREG = str_replace("/", "\/", $HTTP_FILES_PATH);

#     $SUB_FOLDER
$SUB_FOLDER_PREG = str_replace("/", "\/", $SUB_FOLDER);
$parsed_url['path'] = preg_replace("/^(".$SUB_FOLDER_PREG.")(.*?)$/is", "\$2", $parsed_url['path']);

if (preg_match("/^".$HTTP_FILES_PATH_PREG."([0-9uct]+)\/([0-9]+\/)?h_([0-9A-Z]{32})$/i", $parsed_url['path'], $matches)) {

	if ($matches[1]!="u" && $matches[1]!="c" && $matches[1]!="t") $matches[1] = intval($matches[1]);

	if ( strlen($matches[2]) ) {
		$File_Path = $matches[1]."/".$matches[2];
	}
	else {
		$File_Path = $matches[1]."/";
	}
	
	$file_path = $FILES_FOLDER.$File_Path.$matches[3];

  if ( file_exists($file_path) ) {

		@ob_end_clean();
		# sic (remove header)
		if($use_gzip_compression) header("Content-Encoding: ");

		$last_modified = gmdate( "D, d M Y H:i:s", filemtime($file_path) );

		if( !function_exists("apache_request_headers") ) {
			function apache_request_headers() {
				$arh = array();
				$rx_http = '/\AHTTP_/';
				foreach ($_SERVER AS $key => $val) {
					if ( preg_match($rx_http, $key) ) {
						$arh_key = preg_replace($rx_http, '', $key);
						$rx_matches = array();
						// do some nasty string manipulations to restore the original letter case
						// this should work in most cases
						$rx_matches = explode('_', $arh_key);
						if ( count($rx_matches) > 0 AND strlen($arh_key) > 2 ) {
							foreach ($rx_matches AS $ak_key => $ak_val) $rx_matches[$ak_key] = ucfirst($ak_val);
							$arh_key = implode('-', $rx_matches);
						}
						if($val != '') $arh[$arh_key] = $val;
					}
				}
        return( $arh );
			}
		}

		$request_headers = apache_request_headers();

		foreach ($request_headers AS $key => $value) {
		  if ( preg_match("/^If-Modified-Since$/is", $key) ) {
				if ( $value && strtotime($value)>=strtotime($last_modified) ) {
					if ($PHP_TYPE!="cgi") { 
						header($_SERVER['SERVER_PROTOCOL']." 304 Not Modified");
					}
					else {
						header("Status: 304 Not Modified");
					}
					exit; 
				}
			}
		} 
		
    $file_data = $db->get_row("SELECT `Real_Name`, `File_Type`, `File_Size`
  		FROM `Filetable`
  		WHERE `Virt_Name` = '".$matches[3]."'
  		AND `File_Path` = '/".$File_Path."'
  		LIMIT 1", ARRAY_N);
    
    if ( !empty($file_data) ) {
      
      list ($Real_Name, $File_Type, $File_Size) = $file_data;

      if (!strlen($File_Type)) $File_Type = "application/octet-stream";
      
  		header($_SERVER['SERVER_PROTOCOL']." 200 OK");
      // for CGI header
      if ($PHP_TYPE=="cgi") header("Status: 200 OK");

  		header("Last-Modified: ".$last_modified);
  		header("Content-type: ".$File_Type);
  		header("Content-Disposition: inline; filename=\"".urldecode($Real_Name)."\"");
  		header('Content-Transfer-Encoding: binary');

  		if ($File_Size) {
  			header("Content-Length: ".$File_Size);
  			header("Connection: close");
  		}

      echo @file_get_contents($file_path);
      
      exit;
    }
	}
}

$client_source_url = $parsed_url['scheme']."://".($parsed_url['user'] ? $parsed_url['user'] : "").($parsed_url['pass'] ? ":".$parsed_url['pass'] : "").(($parsed_url['user'] || $parsed_url['pass'])?"@":"").$parsed_url['host'].($parsed_url['port']?":".$parsed_url['port']:"").$parsed_url['path'];

$catalogue = "";
$sub = "";
$cc = "";
$classID = "";
$user_table_mode = false;
$admin_mode = false;
$system_table_fields = array();

$current_catalogue = GetCatalogueByHostName($HTTP_HOST);

$catalogue = $current_catalogue["Catalogue_ID"];
// no catalogues? database is empty? system is not installed?
if (!$catalogue) {
  $count_tables = $db->get_var("SHOW TABLES LIKE 'Settings'");
  if (!$count_tables) {
    if (file_exists($DOCUMENT_ROOT.$SUB_FOLDER."/install/index.php")) {
      header("Location: ".$SUB_FOLDER."/install/");
    }
    else {
      trigger_error("<p><b>".NETCAT_ERROR_DB_CONNECT."</b></p>",E_USER_ERROR);
    }
  }
}

// if robots.txt wanted
if ($parsed_url['path'] == '/robots.txt') {
  header($_SERVER['SERVER_PROTOCOL']." 200 OK");
  // for CGI header
  if ($PHP_TYPE=="cgi") header("Status: 200 OK");
  header("Last-Modified: ".$current_catalogue['LastUpdated']);
  header("Content-type: text/plain");
  header("Content-Length: ".strlen($current_catalogue['Robots']));
  echo $current_catalogue['Robots'];
  exit;
}

// modules
LoadModuleEnv();

$e404_sub = $current_catalogue["E404_Sub_ID"];
$title_sub = $current_catalogue["Title_Sub_ID"];
$page_not_found = false;

$req_file = strrchr($parsed_url['path'], '/');

if ( $req_file != '/' ) {

  $req_file = substr($req_file, 1);
  $req_file_parts = explode(".", $req_file);

  $fname = $req_file_parts[0];
  $fext = strtolower($req_file_parts[count($req_file_parts)-1]);

  if ($fext == "html") {
    // name without extension
    $parsed_url['path'] = substr ($parsed_url['path'], 0, strlen($parsed_url['path']) - strlen($req_file));
    // find date
    preg_match("|
      / (\d{4}) /
      (?:
        (\d{2}) /
      )?
      (?:
        (\d{2}) /
      )?
    |x", $parsed_url['path'], $regs);
    // date found in url, make correct hidden_url
    if ($regs) {
      $parsed_url_pathtmp = str_replace($regs[0], "/", $parsed_url['path']);
      array_shift($regs);
      $date_tmp = join("-", $regs);
    }
    // find
    // ORDER BY b.`Checked`, b.`Priority` - Using temporary; Using filesort!!!
    $res = $db->get_results("SELECT a.`Subdivision_ID`, a.`UseMultiSubClass`, b.`Sub_Class_ID`, b.`Class_ID`, c.`System_Table_ID`
      FROM `Subdivision` AS a
      LEFT JOIN `Sub_Class` AS b ON a.`Subdivision_ID` = b.`Subdivision_ID`
      LEFT JOIN `Class` AS c ON b.`Class_ID` = c.`Class_ID`
      WHERE (a.`Hidden_URL` = '".$parsed_url['path']."' OR a.`Hidden_URL` = '".$parsed_url_pathtmp."')
      AND a.`Catalogue_ID` = '".(int)$catalogue."'
      ORDER BY b.`Checked`, b.`Priority`", ARRAY_N);

    if ($db->num_rows) {
      foreach ($res AS $row) {
        list ($subdivisionID, $use_multi_sub_class, $subClassID, $classID, $sysTbl) = $row;
        // find message with need params
        if ( $result = ObjectExists($classID, $sysTbl, $subClassID, $fname) ) {
          $action = "full";
          $message = $result;
          $cc = $subClassID;
          $sub = $subdivisionID;
          break;
        }
      }
    }

    if (!$message) {
      if (ereg ("([-[:alnum:]]+)_([0-9]+)", $fname, $regs) && ($fname == $regs[1]."_".$regs[2])) {
        $cc_keyword = $regs[1];
        $message = $regs[2];
        $action = "full";
      }
      elseif ( ereg("([[:alnum:]]+)_([-[:alnum:]]+)", $fname, $regs) && ($fname == $regs[1]."_".$regs[2]) && ($regs[1]=="add" || $regs[1]=="search" || $regs[1]=="subscribe")) {
        $action = $regs[1];
        $cc_keyword = $regs[2];
      }
      else {
        $cc_keyword = $fname;
      }
    }
  }
  else {
    $parsed_url['path'].= "/";
    $redirect_to_url = $client_source_url."/".($parsed_url['query'] ? "?".$parsed_url[query] : "").($parsed_url['fragment'] ? "#".$parsed_url['fragment'] : "");
  }
}

// find date in url
preg_match("|
  / (\d{4}) /
  (?:
    (\d{2}) /
  )?
  (?:
    (\d{2}) /
  )?
|x", $parsed_url['path'], $regs);
// date found
if ($regs) {
  $parsed_url_pathtmp = str_replace($regs[0], "/", $parsed_url['path']);
  array_shift($regs);
  $date_tmp = join("-", $regs);
}

$sub = $parsed_url['path']=="/" ? $title_sub : GetSubdivisionID($catalogue, $parsed_url['path']);

if (!$sub) {
  $sub = GetSubdivisionID($catalogue, $parsed_url_pathtmp);
  if ($sub) $date = $date_tmp;
}

if ( !isset($use_multi_sub_class) ) {
  // check in $_cache variable
  if (is_array($_cache) && $_cache["sub"][$sub]["Subdivision_ID"] == $sub) {
    $use_multi_sub_class = $_cache["sub"][$sub]["UseMultiSubClass"];
  }
  else {
    $use_multi_sub_class = $db->get_var("SELECT `UseMultiSubClass` FROM `Subdivision` WHERE `Subdivision_ID` = '".(int)$sub."'");
  }
}

if ($sub && $redirect_to_url) {
  if ($REDIRECT_STATUS == "on") {
    if ($AUTHORIZATION_TYPE == 'session') {
      $redirect_to_url.= substr($redirect_to_url, -1)!='l' && substr($redirect_to_url, -1)!='/' ? "&" : "?";
      $redirect_to_url.= session_name()."=".session_id();
    }
    header("Location: ".$redirect_to_url);
    exit;
  }
}

AttemptToRedirect($client_source_url);

if ($sub) {
  // used in loadenv();
  $cc_array = array();
  $cc_in_sub = $db->get_results("SELECT sc.*, c.`System_Table_ID`
    FROM `Sub_Class` AS sc 
    LEFT JOIN `Class` AS c ON sc.`Class_ID` = c.`Class_ID`
    WHERE sc.`Subdivision_ID` = '".(int)$sub."'
    ORDER BY sc.`Priority`", ARRAY_A);
    
  if ( !empty($cc_in_sub) ) {
    foreach ($cc_in_sub AS $row) {
      if ( ($cc_keyword && $row['EnglishName'] == $cc_keyword) || // we've got keyword
          (!$cc_keyword && !$cc && $row['Checked']) || // or class is active and we don't know $cc yet
          (!$cc_keyword && $row['System_Table_ID'] == 3)
      ) {
        $cc = $row["Sub_Class_ID"]; // current class
        $classID = $row["Class_ID"];
        $default_action = $row["DefaultAction"];
        $system_table = $row["System_Table_ID"];
      }
      // $cc_array, used in loadenv()
      if ($row['Checked']) $cc_array[] = $row["Sub_Class_ID"];
    }
  }

  if (!$action) $action = $default_action;
  if ($system_table) $user_table_mode = true;
  // $last_updated    
/*
   $last_update , ..  Last-Modified   
  if ($sub != $title_sub) {
    if ($classID && !$user_table_mode) {
      $last_updated = $db->get_var("SELECT MAX(UNIX_TIMESTAMP(`LastUpdated`)) FROM `Message".(int)$classID."`
        WHERE `Subdivision_ID` = '".(int)$sub."'
        AND `Sub_Class_ID` = '".(int)$cc."'
        AND `Checked` = 1
        ORDER BY `LastUpdated` DESC");
    }
    if ($classID && !$user_table_mode && $message) {
      $last_updated = $db->get_var("SELECT UNIX_TIMESTAMP(`LastUpdated`) FROM `Message".(int)$classID."`
        WHERE `Message_ID` = '".(int)$message."'");
    }
  }
*/
  if ($cc && $date) {
    $FieldID = $db->get_var("SELECT `Field_ID` FROM `Field`
      WHERE (`Format` = 'event' OR `Format` = 'event_date')
      AND `TypeOfData_ID` = 8 AND `Class_ID` = '".(int)$classID."'");
    if (!$FieldID) $page_not_found = true;
  }

  if ( ( ($cc_keyword && !$message) || (!$cc && !$cc_keyword) ) && $date ) {
    $page_not_found = true;
  }

  if ($cc_keyword && !$cc) $page_not_found = true;

  if ($message && $action=="full") {
    $res = $db->query("SELECT `".($user_table_mode ? "User" : "Message")."_ID`
      FROM `".($user_table_mode ? "User" : "Message".$classID)."`
      WHERE `".($user_table_mode ? "User" : "Message")."_ID` = '".$message."'");
    if (!$db->num_rows) $page_not_found = true;
  }
}

// Front user mode
$action_arr = array("index", "full", "add", "search", "subscribe");
if ( !in_array($action, $action_arr) ) $action = "index";

if ( in_array($sub, preg_split("/\s*,\s*/", $MODULE_VARS['auth']['USER_MODIFY_SUB'])) ) {
  $action = 'message';
  $user_table_mode = true;
}

if ( !$catalogue ) exit;
if ( !$sub ) $page_not_found = true;
if ( !$action ) $action = "index";

if ( $page_not_found ) {
  $sub = $e404_sub;
  header($_SERVER['SERVER_PROTOCOL']." 404 Not Found");
  $cc = "";
  $date = "";
  $action = "index";
}
else {
  header($_SERVER['SERVER_PROTOCOL']." 200 OK");
  // for CGI header
  if ($PHP_TYPE=='cgi') header("Status: 200 OK");

  switch ($_SERVER['SERVER_PROTOCOL']) {
    case "HTTP/1.0":
      header("Pragma: no-cache");
    break;
    default:
      header("Cache-Control: no-store, no-cache, must-revalidate");
      header("Cache-Control: post-check=0, pre-check=0", false);
  }
  /*  Last-Modified
  if ($last_updated && $sub != $title_sub) {
    header("Last-Modified: ".gmdate('D, d M Y H:i:s', $last_updated));
  }
  else {
    header("Last-Modified: ".gmdate('D, d M Y H:i:s', time() - 86400));
  }
  */
}

if ($AUTHORIZATION_TYPE == 'session') {
  $sname = session_name();

  if ($$sname!= "") {
    // if "session.hash_function" set as "0", used md5() 128 bits alg else if "1" SHA-1 160 bits alg
    // if "raw_output" second parameter in md5() setted, hash length==16 else length==32
    // for SHA-1 alg:
    // 4 - 40 character string
    // 5 - 32 character string
    // 6 - 27 character string
    $session_hash_alg = ini_get("session.hash_function");
    switch ( ini_get("session.hash_bits_per_character") ) {
      case 5:
        $session_name_regexp = "/^[a-v0-9]{".($session_hash_alg ? "40" : "16,32")."}$/s";
        preg_match($session_name_regexp, $$sname, $matches);
      break;
      case 6:
        $session_name_regexp = "/^[a-z0-9,\-]{".($session_hash_alg ? "32" : "16,32")."}$/is";
      break;
      default:
        $session_name_regexp = "/^[a-f0-9]{".($session_hash_alg ? "27" : "16,32")."}$/s";
    }
    if ( !preg_match($session_name_regexp, $$sname) ) header ("Location: /");
    $_GET[session_name()] = $$sname;
    $_POST[session_name()] = $$sname;
  }
  else {
    srand( (double)microtime() * 1000000 );
    $randval = rand();
    $session_id = md5( uniqid($randval) );
    session_id($session_id);
  }
  
  session_start();
  if ($_SESSION['User']['IsLogin']=="1") {
    if ($_SESSION['User']['IP']!= getenv("REMOTE_ADDR")) header ("Location: /");
    if ((time()-$_SESSION['User']['datetime']) > ini_get('session.gc_maxlifetime')) {
      unset($_SESSION['User']);
      session_destroy();
    }
  }
  $_SESSION['User']['datetime'] = time();
}

$passed_thru_404 = true;
require $ROOT_FOLDER.$action.".php";

if ( is_object($nccttimer) && $nccttimer ) {
  $nccttimer->stop();
  $nccttimer->display();
  dump($db->groupped_queries);
}

?>