<?php
/* $Id: s_browse.inc.php 2271 2008-09-26 12:43:12Z vadim $ */


function s_browse_path ($browse_template) {
	global $sub_level_count;
	return s_browse_path_range(-1, $sub_level_count, $browse_template);
}


/**
  *      
  * @var integer       .
  *       -1 -   ..  
  *       0  -   
  *       1  -   etc
  * @var integer       :
  *       $sub_level_count -  
  *       $sub_level_count-1 -    etc.
  * @var array
  * @return string
  */
function s_browse_path_range ($from, $to, $browse_template) {
	global $REQUEST_URI, $f_title;
	global $admin_mode, $admin_url_prefix;
	global $current_catalogue, $current_sub, $current_cc, $cc_array;
	global $parent_sub_tree, $sub_level_count;
	global $titleTemplate, $action, $message, $classID;
	global $user_table_mode, $db, $SUB_FOLDER;

	eval("\$result = \"".$browse_template['prefix']."\";");

	if ($to > $sub_level_count) $to = $sub_level_count;

	if ($from < -1) $from = -1;

	if ($current_catalogue["Title_Sub_ID"]==$current_sub["Subdivision_ID"]) $from++;

	for ($i = $to; $i > $from; $i--) {
		$nav_name = $parent_sub_tree[$i]["Subdivision_Name"];
		if ($admin_mode) {
			$nav_url = $admin_url_prefix."?catalogue=".$parent_sub_tree[$i]["Catalogue_ID"].($parent_sub_tree[$i]["Subdivision_ID"]?"&amp;sub=".$parent_sub_tree[$i]["Subdivision_ID"]:"");
		}
		else {
			if ($ext_url=$parent_sub_tree[$i]["ExternalURL"]) {
        $nav_url = (strchr($ext_url, ":") || substr($ext_url, 0, 1)=="/") ? $ext_url : $parent_sub_tree[$i]["Hidden_URL"].$ext_url;
      }
			else {
        $nav_url = $parent_sub_tree[$i]["Hidden_URL"];
      }
		}

		if ($current_sub["Subdivision_ID"]==$parent_sub_tree[$i]["Subdivision_ID"]) {
			if ($nav_url==$REQUEST_URI && $browse_template['active_link']) {
				eval("\$result.= \"".$browse_template['active_link']."\";");
			}
			else {
				eval("\$result.= \"".$browse_template['active']."\";");
			}
		}
		else {
			eval("\$result.= \"".$browse_template['unactive']."\";");
		}

		$result = str_replace("%NAME", $nav_name, $result);
		if(!$admin_mode) $nav_url = $SUB_FOLDER.$nav_url;
		$result = str_replace("%URL", $nav_url, $result);

		if (($i-1)!=$from) {
			eval("\$result.= \"".$browse_template['divider']."\";");
		}
	}

	if ($from==-1) {
		if ($current_cc["Sub_Class_ID"]!=$cc_array[0] && $current_cc["Checked"]) {
			eval("\$result.= \"".$browse_template['divider']."\";");

			$nav_name = $current_cc["Sub_Class_Name"];
			$nav_url = $current_sub["Hidden_URL"].$current_cc["EnglishName"].".html";

			if ($nav_url==$REQUEST_URI && $browse_template['active_link']) {
				eval("\$result.= \"".$browse_template['active_link']."\";");
			}
			else {
				eval("\$result.= \"".$browse_template['active']."\";");
			}

			$result = str_replace("%NAME", $nav_name, $result);
			if(!$admin_mode) $nav_url = $SUB_FOLDER.$nav_url;
			$result = str_replace("%URL", $nav_url, $result);
		}

		if ($titleTemplate && $message && $action=="full") {
			eval("\$result.= \"".$browse_template['divider']."\";");
			if ($browse_template['active_link']) {
				eval("\$result.= \"".$browse_template['active_link']."\";");
			}
			else {
				eval("\$result.= \"".$browse_template['active']."\";");
			}

			$result = str_replace("%NAME", $f_title, $result);
			if(!$admin_mode) $nav_url = $SUB_FOLDER.$nav_url;
			$result = str_replace("%URL", $nav_url, $result);
		}
	}

	eval("\$result.= \"".$browse_template['suffix']."\";");
  
	return $result;
}


function s_browse_catalogue($browse_template) {
	global $db, $current_catalogue;
	global $DOMAIN_NAME, $REQUEST_URI;
	global $admin_mode, $admin_url_prefix;
	global $system_table_fields, $HTTP_FILES_PATH, $SUB_FOLDER;

  // cache section
  if ( nc_module_check_by_keyword("cache") && $current_catalogue['Cache_Access_ID']==1 && $browse_template['nocache']!=true ) {
    try {
      $nc_cache_browse = nc_cache_browse::getObject();
      // check cached data
      $cached_data = $nc_cache_browse->read($current_catalogue, $browse_template, $REQUEST_URI, $current_catalogue['Cache_Lifetime']);
      if ($cached_data!=-1) {
        // debug info
        $cache_debug_info = "Readed, catalogue[".$current_catalogue['Catalogue_ID']."], Access_ID[".$current_catalogue['Cache_Access_ID']."], Lifetime[".$current_catalogue['Cache_Lifetime']."], bytes[".strlen($cached_data)."]";
        $nc_cache_browse->debugMessage($cache_debug_info, __FILE__, __LINE__);
        // return cache 
        return $cached_data;
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_browse->errorMessage($e);
    }
  }
  
	if ($browse_template['sortby']) {
    $sort_by = $browse_template['sortby'];
  }
  else {
    $sort_by = "`Priority`";
  }

	$file_fields = array();

	for($i=0; $i<count($system_table_fields['Catalogue']); $i++) {
		// file field
    if ($system_table_fields['Catalogue'][$i]['type']==6) {
      $field_string.= "IF(`".$system_table_fields['Catalogue'][$i]['name']."` <> '', CONCAT('".$HTTP_FILES_PATH.$system_table_fields['Catalogue'][$i]['id']."_', `Catalogue_ID`, RIGHT(SUBSTRING_INDEX(`".$system_table_fields['Catalogue'][$i]['name']."`, ':', 1), LOCATE('.', REVERSE(SUBSTRING_INDEX(`".$system_table_fields['Catalogue'][$i]['name']."`, ':', 1))))), '') AS ".$system_table_fields['Catalogue'][$i]['name'].", ";
      $file_fields[$system_table_fields['Catalogue'][$i]['id']] = $system_table_fields['Catalogue'][$i]['name'];
		}
		else {
		  $field_string.= "`".$system_table_fields['Catalogue'][$i]['name']."`, ";
		}
	}

	$data = $db->get_results("SELECT ".$field_string."`Catalogue_ID`, `Catalogue_Name`, `Domain`
    FROM `Catalogue` WHERE `Checked` = 1 ORDER BY ".$sort_by, ARRAY_A);
	$data_count = sizeof($data);

	if (!$data_count) return;

	eval("\$result = \"".$browse_template['prefix']."\";");

	for ($i=0; $i < $data_count; $i++) {
		$nav_name = $data[$i]["Catalogue_Name"];

		if ($admin_mode) {
		  $nav_url = $admin_url_prefix."?catalogue=".$data[$i]["Catalogue_ID"];
    }
		else {
      $nav_url = "http://".$data[$i]["Domain"].( !strchr($data[$i]["Domain"],".") && $data[$i]["Domain"] ? ".".$DOMAIN_NAME : (!$data[$i]["Domain"] ? $DOMAIN_NAME : "") );
    }

  	foreach ($file_fields AS $file_field_id => $file_field_name) {
			if ($data[$i][$file_field_name]) {
		   	$file_name = $db->get_var("SELECT `Virt_Name` FROM `Filetable`
          WHERE `File_Path` = '/c/'
          AND `Message_ID` = '".$data[$i]['Catalogue_ID']."'
          AND `Field_ID` = '".(int)$file_field_id."'");
		   	if ($file_name) {
		   		$data[$i][$file_field_name] = $SUB_FOLDER.$HTTP_FILES_PATH."c/h_".$file_name;
		   		$data[$i][$file_field_name."_url"] = $SUB_FOLDER.$HTTP_FILES_PATH."c/".$file_name;
		   	}
		   	else {
		   		$data[$i][$file_field_name."_url"] = $data[$i][$file_field_name];
		   	}
		  }
		}

		if ($data[$i]["Catalogue_ID"]==$current_catalogue["Catalogue_ID"]) {
			if ($REQUEST_URI=="/" && $browse_template['active_link']) {
			  eval("\$result.= \"".$browse_template['active_link']."\";");
      }
			else {
			  eval("\$result.= \"".$browse_template['active']."\";");
      }
		}
		else {
			eval("\$result.= \"".$browse_template['unactive']."\";");
		}

		if ( $i <> ($data_count-1) ) eval("\$result.= \"".$browse_template['divider']."\";");

		$result = str_replace("%NAME", $nav_name,$result);
		if(!$admin_mode) $nav_url = $SUB_FOLDER.$nav_url;
		$result = str_replace("%URL", $nav_url,$result);
		$result = str_replace("%CATALOGUE", $data[$i]["Catalogue_ID"], $result);
		$result = str_replace("%COUNTER", $i, $result);

		for ($j = 0; $j < count($system_table_fields['Catalogue']); $j++) {
      $result = str_replace("%".$system_table_fields['Catalogue'][$j]['name'], $data[$i][ $system_table_fields['Catalogue'][$j]['name'] ], $result);
    }
	}
	eval("\$result.= \"".$browse_template['suffix']."\";");
  
  // cache section
  if ( nc_module_check_by_keyword("cache") && $current_catalogue['Cache_Access_ID']==1 && is_object($nc_cache_browse) && $browse_template['nocache']!=true ) {
    try {
      $bytes = $nc_cache_browse->add($current_catalogue, $browse_template, $REQUEST_URI, $result);
      // debug info
      if ($bytes) {
        $cache_debug_info = "Writed, catalogue[".$current_catalogue['Catalogue_ID']."], Access_ID[".$current_catalogue['Cache_Access_ID']."], Lifetime[".$current_catalogue['Cache_Lifetime']."], bytes[".$bytes."]";
        $nc_cache_browse->debugMessage($cache_debug_info, __FILE__, __LINE__, "ok");
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_browse->errorMessage($e);
    }
  }

	return $result;
}


function s_browse_sub ($browse_parent_sub, $browse_template) {
	global $REQUEST_URI;
	global $admin_mode, $admin_url_prefix;
	global $current_sub;
	global $parent_sub_tree, $sub_level_count, $system_table_fields;
	global $db, $HTTP_FILES_PATH, $SUB_FOLDER;


	// this happens when non-existant sub requested in admin mode
	if (!$current_sub["Subdivision_ID"]) return "";
  
  // cache section
  if ( nc_module_check_by_keyword("cache") && $current_sub['Cache_Access_ID']==1 && $browse_template['nocache']!=true ) {
    try {
      $nc_cache_browse = nc_cache_browse::getObject();
      // check cached data
      $cached_data = $nc_cache_browse->read($current_sub, $browse_template, $REQUEST_URI, $current_sub['Cache_Lifetime'], $browse_parent_sub);
      if ($cached_data!=-1) {
        // debug info
        $cache_debug_info = "Readed, catalogue[".$current_sub['Catalogue_ID']."], sub[".$current_sub['Subdivision_ID']."], Access_ID[".$current_sub['Cache_Access_ID']."], Lifetime[".$current_sub['Cache_Lifetime']."], bytes[".strlen($cached_data)."]";
        $nc_cache_browse->debugMessage($cache_debug_info, __FILE__, __LINE__);
        // return cache 
        return $cached_data;
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_browse->errorMessage($e);
    }
  }

	$field_6_types_2 = array();

	if ($browse_template['sortby']) {
    $sort_by = $browse_template['sortby'];
  }
  else {
    $sort_by = "`Priority`";
  }

	for($i = 0; $i < count($system_table_fields['Subdivision']); $i++) {
		// file field
    if ($system_table_fields['Subdivision'][$i]['type']==6) {
			$field_string.= "IF(`".$system_table_fields['Subdivision'][$i]['name']."` <> '', CONCAT('".$HTTP_FILES_PATH.$system_table_fields['Subdivision'][$i]['id']."_', `Subdivision_ID`, RIGHT(SUBSTRING_INDEX(`".$system_table_fields['Subdivision'][$i]['name']."`, ':', 1), LOCATE('.', REVERSE(SUBSTRING_INDEX(`".$system_table_fields['Subdivision'][$i]['name']."`, ':', 1))))), '') AS ".$system_table_fields['Subdivision'][$i]['name'].", ";
			$field_6_types_2[ $system_table_fields['Subdivision'][$i]['id'] ] = $system_table_fields['Subdivision'][$i]['name'];
		}
		else {
      $field_string.= "`".$system_table_fields['Subdivision'][$i]['name']."`, ";
    }
	}

	$data = $db->get_results("SELECT ".$field_string."
    `Subdivision_ID`,
    `Subdivision_Name`,
    `ExternalURL`,
    `Hidden_URL`,
    `EnglishName`,
    `Catalogue_ID`,
    `Parent_Sub_ID`,
    `Template_ID`,
    `LastUpdated`,
    `Created`,
    `Read_Access_ID`,
    `Write_Access_ID`,
    `Priority`,
    `Checked`,
    `Edit_Access_ID`,
    `Subscribe_Access_ID`,
    `Moderation_ID`,
    `Favorite`
    FROM `Subdivision`
    WHERE `Parent_Sub_ID` = '".(int)$browse_parent_sub."'
    AND `Checked` = 1
    AND `Catalogue_ID` = '".(int)$current_sub["Catalogue_ID"]."'
    ORDER BY ".$sort_by, ARRAY_A);
	$data_count = sizeof($data);

	for ($i = 0; $i < $data_count; $i++) {
		foreach ($field_6_types_2 AS $tmp_key => $tmp_value) {
			// get real path only if field is filled
			if ($data[$i][$tmp_value]) {
				$q = $db->get_row("SELECT `Virt_Name`, `Real_Name`, `File_Size`
          FROM `Filetable`
          WHERE `Message_ID` = '".$data[$i]['Subdivision_ID']."'
          AND `Field_ID` = '".$tmp_key."'", ARRAY_N);

				if ( !empty($q) ) {
					list($Virt_Name, $Real_Name, $File_Size) = $q;
					$data[$i][$tmp_value] = $SUB_FOLDER.$HTTP_FILES_PATH. $data[$i]['Subdivision_ID']."/h_".$Virt_Name;
					$data[$i][$tmp_value."_url"] = $SUB_FOLDER.$HTTP_FILES_PATH.$data[$i]['Subdivision_ID']."/".$Virt_Name;
          $data[$i][$tmp_value."_size"] = $File_Size;
          $data[$i][$tmp_value."_name"] = $Real_Name;
				}
				else {
          // old-style filesystem
          // _size, _name are not filled
					$data[$i][$tmp_value."_url"] = $data[$i][$tmp_value];
				}
			}
		}
	}

	if (!$data_count) return;

	eval("\$result = \"".$browse_template['prefix']."\";");

	for ($i=0; $i<$data_count; $i++) {
		$is_active_sub = 0;

		$nav_name = $data[$i]["Subdivision_Name"];

		if ($admin_mode) {
			$nav_url = $admin_url_prefix."?catalogue=".$current_sub["Catalogue_ID"]."&amp;sub=".$data[$i]["Subdivision_ID"];
		}
    else {
			if ($ext_url=$data[$i]["ExternalURL"]) {
        $nav_url = (strchr($ext_url,":") || substr($ext_url,0,1)=="/")?$ext_url:$data[$i]["Hidden_URL"].$ext_url;
      }
			else {
        $nav_url = $data[$i]["Hidden_URL"];
      }
		}


		for ($j = 0; $j<$sub_level_count; $j++) {
      if ($parent_sub_tree[$j]["Subdivision_ID"]==$data[$i]["Subdivision_ID"]) $is_active_sub = 1;
    }

		if (($current_sub["Subdivision_ID"]==$data[$i]["Subdivision_ID"]) || $is_active_sub) {
			if ($browse_template['active_link'] && $data[$i]['Hidden_URL']==$REQUEST_URI) {
        $thisActive = $browse_template['active_link'];
      }
			else {
        $thisActive = $browse_template['active'];
      }
			eval("\$result.= \"".$thisActive."\";");
		}
    else {
			eval("\$result.= \"".$browse_template['unactive']."\";");
		}

		if ( $i<>($data_count-1) ) eval("\$result .= \"".$browse_template['divider']."\";");

		$result = str_replace("%NAME", $nav_name, $result);
		if(!$admin_mode) $nav_url = $SUB_FOLDER.$nav_url;
		$result = str_replace("%URL", $nav_url, $result);
		$result = str_replace("%PARENT_SUB", $browse_parent_sub, $result);
		$result = str_replace("%KEYWORD", $data[$i]['EnglishName'], $result);
		$result = str_replace("%SUB", $data[$i]["Subdivision_ID"], $result);
		$result = str_replace("%COUNTER", $i, $result);

		for ($j = 0; $j < count($system_table_fields['Subdivision']); $j++) {
      $result = str_replace("%".$system_table_fields['Subdivision'][$j]['name'], $data[$i][ $system_table_fields['Subdivision'][$j]['name'] ], $result);
    }
	}
	eval("\$result.= \"".$browse_template['suffix']."\";");

  // cache section
  if ( nc_module_check_by_keyword("cache") && $current_sub['Cache_Access_ID']==1 && is_object($nc_cache_browse) && $browse_template['nocache']!=true ) {
    try {
      $bytes = $nc_cache_browse->add($current_sub, $browse_template, $REQUEST_URI, $result, $browse_parent_sub);
      // debug info
      if ($bytes) {
        $cache_debug_info = "Writed, catalogue[".$current_sub['Catalogue_ID']."], sub[".$current_sub['Subdivision_ID']."], Access_ID[".$current_sub['Cache_Access_ID']."], Lifetime[".$current_sub['Cache_Lifetime']."], bytes[".$bytes."]";
        $nc_cache_browse->debugMessage($cache_debug_info, __FILE__, __LINE__, "ok");
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_browse->errorMessage($e);
    }
  }
  
	return $result;
}


function s_browse_level($level, $browse_template) {
	global $parent_sub_tree, $sub_level_count;

	$level_id = $sub_level_count - $level;
	if (!$parent_sub_tree[$level_id]["Subdivision_ID"] && $level) return;
	$parent_sub_tree[$level_id]["Subdivision_ID"] += 0;

	return s_browse_sub($parent_sub_tree[$level_id]["Subdivision_ID"], $browse_template);
}


function s_browse_cc ($browse_template) {
	global $db;
	global $admin_mode,$admin_url_prefix;
	global $current_cc, $current_sub;
	global $cc_in_sub, $cc_array, $cc_keyword, $use_multi_sub_class;
	global $REQUEST_URI, $SUB_FOLDER;

  // this happens when non-existant sub requested in admin mode
	if (!$current_sub["Subdivision_ID"]) return "";
  
  // cache section
  if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID']==1 && $browse_template['nocache']!=true ) {
    try {
      $nc_cache_browse = nc_cache_browse::getObject();
      // check cached data
      $cached_data = $nc_cache_browse->read($current_cc, $browse_template, $REQUEST_URI, $current_cc['Cache_Lifetime']);
      if ($cached_data!=-1) {
        // debug info
        $cache_debug_info = "Readed, catalogue[".$current_cc['Catalogue_ID']."], sub[".$current_cc['Subdivision_ID']."], cc[".$current_cc['Sub_Class_ID']."], Access_ID[".$current_cc['Cache_Access_ID']."], Lifetime[".$current_cc['Cache_Lifetime']."], bytes[".strlen($cached_data)."]";
        $nc_cache_browse->debugMessage($cache_debug_info, __FILE__, __LINE__);
        // return cache 
        return $cached_data;
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_browse->errorMessage($e);
    }
  }
  
	if ($browse_template['sortby']) {
    $sort_by = $browse_template['sortby'];
  }
  else {
    $sort_by = "`Priority`";
  }
	if (!$admin_mode) $check_cond = " AND `Checked` = 1";

	// cc_in_sub has all templates in sub
	$data = array();

	if ($sort_by=='Priority' && $GLOBALS['sub']==$current_sub["Subdivision_ID"])
	{
		foreach ( (array)$cc_in_sub AS $row ) {
			if ($admin_mode || $row["Checked"]==1) {
				$data[] = $row;
			}
		}
	}

	if ( empty($data) ) {
		$data = $db->get_results("SELECT `Sub_Class_ID`, `Sub_Class_Name`, `EnglishName` FROM `Sub_Class`
      WHERE `Subdivision_ID` = '".$current_sub["Subdivision_ID"]."'".$check_cond." ORDER BY ".$sort_by, ARRAY_A);
	}
	$data_count = sizeof($data);

	if (!$data_count || $data_count < 2) return;

	eval("\$result.= \"".$browse_template['prefix']."\";");

	for ($i = 0; $i < $data_count; $i++) {
		$nav_name = $data[$i]["Sub_Class_Name"];

		if ($admin_mode) {
      $nav_url = $admin_url_prefix."?catalogue=".$current_sub["Catalogue_ID"]."&amp;sub=".$current_sub["Subdivision_ID"]."&amp;cc=".$data[$i]["Sub_Class_ID"];
		}
    else {
      $nav_url = $current_sub["Hidden_URL"].$data[$i]["EnglishName"].".html";
    }

		if ($data[$i]["Sub_Class_ID"] == $current_cc["Sub_Class_ID"] && ($cc_keyword || !$use_multi_sub_class)) {
			if ($browse_template['active_link'] && ($current_sub['Hidden_URL']==$REQUEST_URI || $current_sub['Hidden_URL'].$current_cc['EnglishName'].".html"==$REQUEST_URI)) {
        $thisActive = $browse_template['active_link'];
			}
      else {
        $thisActive = $browse_template['active'];
      }
			eval("\$result.= \"".$thisActive."\";");
		}
    else {
			eval("\$result.= \"".$browse_template['unactive']."\";");
		}

		$result = str_replace("%NAME", $nav_name, $result);
		if(!$admin_mode) $nav_url = $SUB_FOLDER.$nav_url;
		$result = str_replace("%URL", $nav_url, $result);

		if ( $i!=($data_count-1) ) eval("\$result.= \"".$browse_template['divider']."\";");
	}
	eval("\$result.= \"".$browse_template['suffix']."\";");
  
  // cache section
  if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID']==1 && is_object($nc_cache_browse) && $browse_template['nocache']!=true ) {
    try {
      $bytes = $nc_cache_browse->add($current_cc, $browse_template, $REQUEST_URI, $result);
      // debug info
      if ($bytes) {
        $cache_debug_info = "Writed, catalogue[".$current_cc['Catalogue_ID']."], sub[".$current_cc['Subdivision_ID']."], cc[".$current_cc['Sub_Class_ID']."], Access_ID[".$current_cc['Cache_Access_ID']."], Lifetime[".$current_cc['Cache_Lifetime']."], bytes[".$bytes."]";
        $nc_cache_browse->debugMessage($cache_debug_info, __FILE__, __LINE__, "ok");
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_browse->errorMessage($e);
    }
  }
  
	return $result ;
}

?>