<?php
/* $Id: s_e404.inc.php 2440 2008-11-27 16:47:15Z vadim $ */

function ObjectExists ($classID, $sysTbl, $cc, $keyword) {
  global $db;

  $res = $db->get_var("SELECT `".($sysTbl ? "User" : "Message")."_ID`
    FROM `".($sysTbl ? "User" : "Message".intval($classID))."`
    WHERE `Keyword` = '".$db->escape($keyword)."'".(!$sysTbl ? " AND `Sub_Class_ID` = '".intval($cc)."'" : ""));
  
  if ($db->num_rows) {
    $msgID = $res;
    return $msgID;
  }

  return false;
}

/**
 *        hostname
 *
 * @param string $host
 * @return array
 */
function GetCatalogueByHostName($host) {
  global $db;

  $res = $db->get_row("(SELECT * FROM `Catalogue`
    WHERE Domain = '".$db->escape($host)."'
    OR (CONCAT('|', REPLACE(Mirrors, '\\n', '|')) LIKE '%|".$db->escape($host)."%') LIMIT 1)
    UNION (SELECT * FROM `Catalogue` ORDER BY `Checked` = 1, `Priority`, `Catalogue_ID` LIMIT 1)
    LIMIT 1", ARRAY_A);
  
  return $res;
}

//
function GetCatalogueID ($host) {
  global $db, $DOMAIN_NAME;

  $res = $db->get_var("SELECT `Catalogue_ID` FROM `Catalogue` WHERE IF(LOCATE('.',Domain),Domain,IF(Domain<>'',CONCAT(Domain,'.".$db->escape($DOMAIN_NAME)."'),'".$db->escape($DOMAIN_NAME)."'))='".$db->escape($host)."'");
  
  if ($db->num_rows) {
    $CatalogueID = $res;
    return ($CatalogueID);
  }
  else {
    $res = $db->get_results("SELECT `Catalogue_ID`, `Mirrors` FROM `Catalogue` ORDER BY `Catalogue_ID`", ARRAY_N);
    if ( empty($res) ) return 0;
    foreach ($res as $row) {
      list($CatalogueID, $Mirrors) = $row;
      $DomainArray = explode("\n",$Mirrors);
      for ($i=0; $i < count($DomainArray); $i++) {
        if ( trim($DomainArray[$i])==$host ) {
          return ($CatalogueID);
        }
      }
    }
  }
  return 0;
}

/**
  *       
  */
function GetSubdivisionByID($sub) {
  global $_cache, $db;
  $sub = (int)$sub;

  if (!$_cache["sub"][$sub]) {
    $_cache["sub"][$sub] = $db->get_row("SELECT * FROM `Subdivision` WHERE `Subdivision_ID` = '".intval($sub)."'", ARRAY_A);
  }

  return $_cache["sub"][$sub];
}


function GetSubdivisionID ($catalogue, $path) {
  global $db, $_cache;

  $row = $db->get_row("SELECT * FROM `Subdivision` WHERE `Catalogue_ID` = '".intval($catalogue)."' AND `Hidden_URL` = '".$db->escape($path)."'", ARRAY_A);

  $_cache["sub"][$row["Subdivision_ID"]] = $row;
  
  return $row["Subdivision_ID"];
}


function AttemptToRedirect ($url) {
  global $db, $REDIRECT_STATUS, $PHP_TYPE;
  
  $res = $db->get_row("SELECT REPLACE(NewURL,'*','\\\'),REPLACE(OldURL,'*','([[:alnum:]]+)') FROM `Redirect`
    WHERE '".$db->escape($url)."' LIKE CONCAT('http://',REPLACE(REPLACE(OldURL,'_','\\\_'),'*','%'))
    OR '".$db->escape($url)."' LIKE CONCAT('http://www.',REPLACE(REPLACE(OldURL,'_','\\\_'),'*','%')) ORDER BY LENGTH(OldURL) DESC LIMIT 1", ARRAY_N);
  
  if (!$db->num_rows) return 0;

  list($new_url, $old_url) = $res;

  if ( strchr($new_url, "\\") ) {
    $result_url = ereg_replace($old_url, $new_url, $url);
  }
  else {
    $result_url = "http://".$new_url;
  }

  if ($REDIRECT_STATUS=="on") {
    if ($AUTHORIZATION_TYPE=='session') {
      if ( substr($result_url, -1)!='l' && substr($result_url, -1)!='/' ) {
        $result_url.= "&".session_name()."=".session_id();
      }
      else {
        $result_url.= "?".session_name()."=".session_id();
      }
    }

    if ($PHP_TYPE=='cgi') header('Status: 301 Moved Permanently');

    header("Location: ".$result_url);
  }
  else {
    if ($PHP_TYPE=='cgi') header('Status: 200 OK');
    echo "<meta http-equiv=refresh content='0;url=http://".$result_url."'>";
  }
  exit;
}

?>